pro nsplot_ak_diag_all,instr,xtype,orbit,zone,datestr
;datestr='20181215'
daystr=datestr
; variables defined in namelists
tlev31=[1,  5,  9, 13, 17, 21, 25, 29, 33, 37,$
      41, 45, 49, 53, 56, 59, 62, 65, 68, 71,$
      74, 77, 80, 83, 86, 89, 91, 93, 95, 97,100]
tlev24=[1,  8, 10, 13, 15, 19, 24, 27, 32, 36,$
        39, 43, 47, 51, 56, 61, 66, 71, 75, 80,$
        83, 87, 92, 100]
o3lev=[1,26,35,39,44,49,56,63,80,100]; levozon in ozone*.nl
colev=[1, 20,45,56,63,70,81,89,93,100]; levco in ozone*.nl
watlev22=[1, 33, 45, 49, 53, 56, 59, 62, 65, 68,$
        71, 74, 77, 80, 83, 86, 89, 91, 93, 95, $
        97, 100]; levwatr in water*.nl
watlev12=[1, 39, 52, 61, 64, 66, 70, 76, 81, 85, 91, 100]


; Strucutre of AK file you created
;   LATITUDE        FLOAT     Array[1350]
;   LONGITUDE       FLOAT     Array[1350]
;   TSURF           FLOAT     Array[1350]
;   LANDFRAC        FLOAT     Array[1350]
;   VIEWANGLE       FLOAT     Array[1350]
;   SOLZANG         FLOAT     Array[1350]
;   TAK             FLOAT     Array[31, 31, 1350]
;   TAK2            FLOAT     Array[31, 31, 1350]
;   H2OAK           FLOAT     Array[22, 22, 1350]
;   O3AK            FLOAT     Array[10, 10, 1350]
;   COAK            FLOAT     Array[10, 10, 1350]
;   CH4AK           FLOAT     Array[12, 12, 1350]
;   TDOF            FLOAT     Array[1350]
;   H2ODOF          FLOAT     Array[1350]
;   O3DOF           FLOAT     Array[1350]
;   CODOF           FLOAT     Array[1350]
;   CH4DOF          FLOAT     Array[1350]
;   QCMASK          LONG      Array[1350]

; load standard 100 layer pressure array
restore,'/home/nadias/data/basics.sav'; nlev, pobs
plev=pobs
nlev=n_elements(plev)

; date
yy=strmid(daystr,0,4)
mm=strmid(daystr,4,2)
dd=strmid(daystr,6,2)

; data directory
ddir='/peate_sci/nadias/ak/'+yy+'/'+mm+'/'+dd

; output figure name
jname=xtype+'caps_'+instr+'_all_AK_diag_'+datestr+'_'+orbit+'_zone'+strtrim(zone,1)+'.jpg'

; find all the files to plot
filespec=ddir+'/'+xtype+'caps_'+orbit+'*.nc'
print,filespec
print,filespec
filelist=findfile(filespec)
nfiles=n_elements(filelist)
print,strtrim(nfiles,1)+' files to process'

; start plotting
claser,psfile="unc.eps",/eps
loadct,20
mcolor=byte(!p.color)
if mcolor eq 0 then mcolor=255
icmm1=mcolor-1
icmm2=mcolor-2
!p.background=255.
!p.color=0
!p.thick=2.0
!p.charsize=1.5
loadct,20;33
cnt=0L

;for n=0,100 do begin
for n=0,nfiles-1 do begin
    	print, 'reading file', filelist(n)
	result=read_ncdf(filelist(n),dat)
;------------------------------------------
;	s=size(dat.latitude)
	nprof=n_elements(dat.latitude)
;	nscan=s(2)
	takmatrix=dat.tak2; final T retrieval [31,31,nobs]
	qakmatrix=dat.h2oak; averaging kernel [22,22,nobs]
	o3akmatrix=dat.o3ak; averaging kernel [10,10,nobs]
	coakmatrix=dat.coak; averaging kernel [10,10,nobs]
        qf=dat.qcmask; [nobs]
	lats=dat.latitude; [nobs]
	lons=dat.longitude; [nobs]

	if n eq 0 then begin
		lev=n_elements(takmatrix(*,1))
print,lev
		if lev eq 31 then tlev = tlev31
		if lev eq 24 then tlev = tlev24
		lev=n_elements(qakmatrix(*,1))
		if lev eq 12 then watlev = watlev12
		if lev eq 22 then watlev = watlev22
; subset pressure arrays
		tplev=plev(tlev)
		o3plev=plev(o3lev)
		coplev=plev(colev)
		qplev=plev(watlev)

		tnlev=n_elements(tplev)
		o3nlev=n_elements(o3plev)
		conlev=n_elements(coplev)
		qnlev=n_elements(qplev)
	endif
; define output array
	
	if n eq 0 then begin
		takout=fltarr(tnlev,nprof*nfiles)*!Values.F_NAN
		qakout=fltarr(qnlev,nprof*nfiles)*!Values.F_NAN
		o3akout=fltarr(o3nlev,nprof*nfiles)*!Values.F_NAN
		coakout=fltarr(conlev,nprof*nfiles)*!Values.F_NAN
	endif
	case zone of
        	0: begin
        	zonestr='Polar [> 60 N/S]'
       		gidx=where(lats ge 60 or lats le -60)
        	cmax=0.4
        	end
        	1: begin
        	zonestr='Mid-Lat [30-60 N/S]'
        	gidx=where((lats ge 30 and lats lt 60) or (lats gt -60 and lats le -30))
		cmax=0.65
        	end
        	2: begin
        	zonestr='Tropics [30 S to 30 N]'
        	gidx=where(lats lt 30 and lats gt -30)
		cmax=0.65
        	end
	endcase
; make geographic subset
	lats=lats(gidx)
	lons=lons(gidx)
	takmatrix=takmatrix(*,*,gidx)
	qakmatrix=qakmatrix(*,*,gidx)
	o3akmatrix=o3akmatrix(*,*,gidx)
	coakmatrix=coakmatrix(*,*,gidx)
	qf=qf(gidx)
	nelem=n_elements(gidx)

; construct and apply a qc mask
	qualmask=fltarr(nelem)
	qualmask(where(qf eq 0))=1.0
	qualmask(where(qf gt 0))=!Values.F_NAN
; subset ak for specific pressure level
	for i=0,nelem-1 do begin
		takout(*,cnt)=diag_matrix(takmatrix(*,*,i))*qualmask(i)
		qakout(*,cnt)=diag_matrix(qakmatrix(*,*,i))*qualmask(i)
		o3akout(*,cnt)=diag_matrix(o3akmatrix(*,*,i))*qualmask(i)
		coakout(*,cnt)=diag_matrix(coakmatrix(*,*,i))*qualmask(i)
		cnt=cnt+1
	endfor
	
endfor

print,'count=',cnt

takout(where(takout lt -100))=!Values.F_NAN
qakout(where(qakout lt -100))=!Values.F_NAN
o3akout(where(o3akout lt -100))=!Values.F_NAN
coakout(where(coakout lt -100))=!Values.F_NAN

figtit=zonestr
takmean=fltarr(tnlev)
qakmean=fltarr(qnlev)
o3akmean=fltarr(o3nlev)
coakmean=fltarr(conlev)
txerr=fltarr(tnlev)
qxerr=fltarr(qnlev)
o3xerr=fltarr(o3nlev)
coxerr=fltarr(conlev)
zeroline=fltarr(nlev)
; calculate mean and stddev of AK profile
for i=0,tnlev-1 do begin
; temperature
	idx=where(abs(takout(i,*)) gt 0) 
	takmean(i)=mean(takout(i,idx))	
	txerr(i)=stddev(takout(i,idx))
endfor
for i=0,qnlev-1 do begin
; water vapor
	idx=where(abs(qakout(i,*)) gt 0) 
	qakmean(i)=mean(qakout(i,idx))	
	qxerr(i)=stddev(qakout(i,idx))
endfor
for i=0,o3nlev-1 do begin
; Ozone
	idx=where(abs(o3akout(i,*)) gt 0) 
	o3akmean(i)=mean(o3akout(i,idx))	
	o3xerr(i)=stddev(o3akout(i,idx))
endfor
for i=0,conlev-1 do begin
; Carbon monoxide
	idx=where(abs(coakout(i,*)) gt 0) 
	coakmean(i)=mean(coakout(i,idx))	
	coxerr(i)=stddev(coakout(i,idx))
endfor

; setup plot
xrange=[0.,0.55]
yrange=[1000.,.1]
yticks=[1000,500,300,100,50,10,1,0.1]
ytickname=['1000.','500.','300.','100.','50.','10.','1.','0.1']

; (1) Temperature
a=errorplot(takmean,tplev,txerr,[0],'-b3',Ytitle='Pressure [hPa]',$
	/ylog,yrange=yrange,font_size=11,$
	/buffer,Xtitle=xtitle,Title='T AK',$
	errorbar_linestyle=0,layout=[4,1,1],$
	errorbar_color='tomato',errorbar_thick=2,dimensions=[1200,500])
a.xrange=xrange
a.xgridstyle=1
a.xminor=0
a.yminor=0
a.ygridstyle=1
a.ysubgridstyle=1
a.yticklen=1
a.xticklen=1
a.ytickvalues=yticks
;t=text(0.3,ypos,'DFS='+avgdof,/data,font_size=14,font_style=1)
;a=plot(akmean-akstd,o3plev,'b*',/buffer,/current,/overplot)
;a=plot(zeroline,nlev,/buffer,/current,/overplot,$
;	linestyle=1,color='gray')
; (2) Water Vapor
a=errorplot(qakmean,qplev,qxerr,[0],'-b3',Ytitle='Pressure [hPa]',$
        /ylog,yrange=yrange,font_size=11,$
        /buffer,/current,Xtitle=xtitle,Title='H2O AK',$
        errorbar_linestyle=0,layout=[4,1,2],$
        errorbar_color='tomato',errorbar_thick=2)
a.xrange=xrange
a.xgridstyle=1
a.xminor=0
a.yminor=0
a.ygridstyle=1
a.ysubgridstyle=1
a.yticklen=1
a.xticklen=1
a.ytickvalues=yticks
;t=text(0.3,ypos,'DFS='+avgdof,/data,font_size=14,font_style=1)
;a=plot(akmean-akstd,o3plev,'b*',/buffer,/current,/overplot)
;a=plot(zeroline,nplev,/buffer,/current,/overplot,$
;        linestyle=1,color='gray')
; (3) Ozone
a=errorplot(o3akmean,o3plev,o3xerr,[0],'-b3',Ytitle='Pressure [hPa]',$
        /ylog,yrange=yrange,font_size=11,$
        /buffer,/current,Xtitle=xtitle,Title='O3 AK',$
        errorbar_linestyle=0,layout=[4,1,3],$
        errorbar_color='tomato',errorbar_thick=2)
a.xrange=xrange
a.xgridstyle=1
a.xminor=0
a.yminor=0
a.ygridstyle=1
a.ysubgridstyle=1
a.yticklen=1
a.xticklen=1
a.ytickvalues=yticks
;a=plot(zeroline,nplev,/buffer,/current,/overplot,$
;        linestyle=1,color='gray')
; (4) Carbon Monoxide
a=errorplot(coakmean,coplev,coxerr,[0],'-b3',Ytitle='Pressure [hPa]',$
        /ylog,yrange=yrange,font_size=11,$
        /buffer,/current,Xtitle=xtitle,Title='CO AK',$
        errorbar_linestyle=0,layout=[4,1,4],$
        errorbar_color='tomato',errorbar_thick=2)
a.xrange=xrange
a.xgridstyle=1
a.xminor=0
a.yminor=0
a.ygridstyle=1
a.ysubgridstyle=1
a.yticklen=1
a.xticklen=1
a.ytickvalues=yticks
;a=plot(zeroline,nplev,/buffer,/current,/overplot,$
;        linestyle=1,color='gray')

a.save,jname,resolution=120
print,'figure saved to '+jname

end
