pro nsplot_ak_diag_double,orbit,zone

instr='npp'

tlev=[1,  8, 10, 13, 15, 19, 24, 27, 32, 36,$
      39, 43, 47, 51, 56, 61, 66, 71, 75, 80,83, 87, 92];, 100]
; can't plot T AK now because the number of levels vary between 21 and 23. 

watlev=[1, 39, 52, 61, 64, 66, 70, 76, 81, 85, 91, 100]; levwatr in water*.nl
o3plev=[0.026,22.16,53.79,74.35,106.586,146.781,217.685,307.015,606.847,1085.40]


fn='/iliad/proxy/nadias/nucaps/npp/2018/11/15/netcdf/NUCAPS-EDR_v2r0_j01_s201811150659359_e201811150700057_c201811150720280.nc'
out=read_ncdf(fn,dat)
plev=dat.pressure(*,1)

watplev=plev(watlev)
;tplev=plev(tlev)
;aknlev=n_elements(o3plev)
;aknlev=n_elements(tplev)
aknlev=n_elements(watplev)
akplev=watplev
; date
daystr='20180321'
datestr='20180321'
yy='2018';strmid(daystr,0,4)
mm='03';strmid(daystr,4,2)
dd='21';strmid(daystr,6,2)

;orbit='pm'
param='H2O'
param='T'
;param='O3'
case zone of 
	0: begin
	zonestr='South Pole'
	zmin=-90
	zmax=-60
	cmax=0.65
	end
	1: begin
	zonestr='South MidLat'
	zmin=-60
	zmax=-30
	cmax=0.65
	end
	2: begin
	zonestr='Tropics'
	zmin=-30
	zmax=30
	cmax=0.65
	end
	3: begin
	zonestr='North MidLat'
	zmin=30
	zmax=60
	cmax=0.65
	end
	4: begin
	zonestr='North Pole'
	zmin=60
	zmax=90
	cmax=0.65
	end
endcase

; data directory
nuddir='/iliad/proxy/nadias/nucaps/'+instr+'/'+yy+'/'+mm+'/'+dd+'/netcdf'
climddir='/iliad/proxy/nadias/climcaps/'+instr+'/'+yy+'/'+mm+'/'+dd+'/netcdf'

; output figure name
jname='allcaps_'+instr+'_'+param+'_AK_diag_'+datestr+'_'+orbit+'_zone'+strtrim(zone,1)+'.jpg'

; find all the files to plot
filespecnu=nuddir+'/nucaps_'+instr+'_'+orbit+'_zone*'+datestr+'*_AK.nc'
filespecclim=climddir+'/climcaps_'+instr+'_'+orbit+'_zone*'+datestr+'*_AK.nc'
print,filespecnu
filelistnu=findfile(filespecnu)
filelistclim=findfile(filespecclim)
nfilesnu=n_elements(filelistnu)
nfilesclim=n_elements(filelistclim)
print,strtrim(nfilesnu,1)+' files to process'

; start plotting
claser,psfile="unc.eps",/eps
loadct,20
mcolor=byte(!p.color)
if mcolor eq 0 then mcolor=255
icmm1=mcolor-1
icmm2=mcolor-2
!p.background=255.
!p.color=0
!p.thick=2.0
!p.charsize=1.5
loadct,20;33
cnt=0L

; READ NUCAPS FILES
;for n=0,100 do begin
for n=0,nfilesnu-1 do begin
    	print, 'reading file', filelistnu(n)
	result=read_ncdf(filelistnu(n),dat)
;------------------------------------------
;	s=size(dat.latitude)
	nprof=n_elements(dat.latitude)
;	akmatrix=dat.h2oak; averaging kernel [12 x 12 30 x 4]
;	akmatrix=dat.o3ak; averaging kernel [10 x 10 x 30 x 4]
	akmatrix=dat.t_ak; averaging kernel [10 x 10 x 30 x 4]
        qf=dat.qcmask; [30 x 4]
	lats=dat.latitude; [30 x 4]
	lons=dat.longitude; [30 x 4]

; define output array
	if n eq 0 then begin
		akout=fltarr(aknlev,nprof*nfilesnu)*!Values.F_NAN
		dofout=fltarr(nprof*nfilesnu)*!Values.F_NAN
	endif

; make geographic subset
	gidx=where(lats lt zmax and lats gt zmin)
	lats=lats(gidx)
	lons=lons(gidx)
	akmatrix=akmatrix(*,*,gidx)
	qf=qf(gidx)
	nelem=n_elements(gidx)

; construct and apply a qc mask
	qualmask=fltarr(nelem)
	qualmask(where(qf eq 0))=1.0
	qualmask(where(qf gt 0))=!Values.F_NAN

; subset ak for specific pressure level
	for i=0,nelem-1 do begin
		akout(*,cnt)=diag_matrix(akmatrix(*,*,i))*qualmask(i)
		cnt=cnt+1
	endfor
	
endfor

cntclim=0
; READ CLIMCAPS FILES
for n=0,nfilesclim-1 do begin
    	print, 'reading file', filelistclim(n)
	result=read_ncdf(filelistclim(n),dat)
;------------------------------------------
;	s=size(dat.latitude)
	nprof=n_elements(dat.latitude)
;	akmatrix=dat.h2oak; averaging kernel [12 x 12 30 x 4]
;	akmatrix=dat.o3ak; averaging kernel [10 x 10 x 30 x 4]
	akmatrix=dat.t_ak; averaging kernel [10 x 10 x 30 x 4]
        qf=dat.qcmask; [30 x 4]
	lats=dat.latitude; [30 x 4]
	lons=dat.longitude; [30 x 4]

; define output array
	if n eq 0 then begin
		akoutclim=fltarr(aknlev,nprof*nfilesclim)*!Values.F_NAN
		dofoutclim=fltarr(nprof*nfilesclim)*!Values.F_NAN
	endif

; make geographic subset
	gidx=where(lats lt zmax and lats gt zmin)
	lats=lats(gidx)
	lons=lons(gidx)
	akmatrix=akmatrix(*,*,gidx)
	qf=qf(gidx)
	nelem=n_elements(gidx)

; construct and apply a qc mask
	qualmask=fltarr(nelem)
	qualmask(where(qf eq 0))=1.0
	qualmask(where(qf gt 0))=!Values.F_NAN

; subset ak for specific pressure level
	for i=0,nelem-1 do begin
		akoutclim(*,cntclim)=diag_matrix(akmatrix(*,*,i))*qualmask(i)
		cntclim=cntclim+1
	endfor
	
endfor

help,akout
print,'count=',cnt
dofout=fltarr(nprof*nfilesnu)
dofoutclim=fltarr(nprof*nfilesclim)

akout(where(akout lt -100))=!Values.F_NAN
akoutclim(where(akoutclim lt -100))=!Values.F_NAN

for i=0,cnt-1 do dofout(i)=total(akout(*,i),/nan)
for i=0,cntclim-1 do dofoutclim(i)=total(akoutclim(*,i),/nan)

idx=where(dofout gt 0)
avgdof=round(mean(dofout(idx),/nan)*1000.)/1000.
avgdof=strtrim(avgdof,1)
avgdof=strmid(avgdof,0,4)

idx=where(dofoutclim gt 0)
avgdofclim=round(mean(dofoutclim(idx),/nan)*1000.)/1000.
avgdofclim=strtrim(avgdofclim,1)
avgdofclim=strmid(avgdofclim,0,4)

figtit='SNPP '+param+' Avg Kernel for '+zonestr
akmean=fltarr(aknlev)
akmeanclim=fltarr(aknlev)
xerr=fltarr(aknlev)
xerrclim=fltarr(aknlev)
zeroline=fltarr(aknlev)
; calculate mean and stddev of AK profile
for i=0,aknlev-1 do begin
	idx=where(abs(akout(i,*)) gt 0) 
	akmean(i)=mean(akout(i,idx))	
	xerr(i)=stddev(akout(i,idx))
	idx=where(abs(akoutclim(i,*)) gt 0) 
	akmeanclim(i)=mean(akoutclim(i,idx))	
	xerrclim(i)=stddev(akoutclim(i,idx))
endfor
print,xerrclim
; plot
climtit='CLIMCAPS, dof='+avgdofclim
nutit='NUCAPS, dof='+avgdof

a1=plot(akmean,akplev,'-b3',Ytitle='Pressure [hPa]',$
	/ylog,yrange=[650.0,10.0],name=nutit,$
	/buffer,Xtitle='Averaging Kernel',Title=figtit,$
	dimensions=[500,800]);,errorbar_linestyle=1,$
	;ytickname=['10','70','100','300','500'],$
	;yminor=-1)
a1.xrange=[-0.05,cmax]
a2=plot(akmeanclim,akplev,color='deep pink',$
	/ylog,/overplot,name=climtit,$
	thick=3)
;l = legend(target=[a1,a2],position=[0.85,0.25])
l = legend(target=[a1,a2],position=[0.85,0.85])
p=plot(zeroline,akplev,/buffer,/current,/overplot,$
	linestyle=1,color='gray')
a1.save,jname,resolution=120
print,'figure saved to '+jname

end
