pro nsplot_ak_diag_doubleT_diff,num
cdbcol
figdir='/home/nadias/figs/'
instr='npp'
zone=4
orbit='am'
xtype='clim'
tlev=[1,  8, 10, 13, 15, 19, 24, 27, 32, 36,$
      39, 43, 47, 51, 56, 61, 66, 71, 75, 80,83, 87, 92, 100]
o3lev=[1,26,35,39,44,49,56,63,80,100]; levozon in ozone*.nl
watlev=[1, 39, 52, 61, 64, 66, 70, 76, 81, 85, 91, 100]; levwatr in water*.nl

yrange=[1000.0,10.0]
ytickv=[1000.,850.,500.,300.,100.,50.,10.]
yticknames=['1000','850','500','300','100','50','10']
yticks=n_elements(ytickv)-1
;fn2='/home/nadias/idl/oz_noprop_s201601141000000_e201601141005580_AK.nc'
;fn2='/home/nadias/idl/ozprop_s201601141000000_e201601141005580_AK.nc'
;fn='/home/nadias/idl/no_oz_noprop_s201601141000000_e201601141005580_AK.nc'
;fn='/home/nadias/idl/no_ozprop_s201601141000000_e201601141005580_AK.nc'
;fn2='/home/nadias/idl/ozprop_s201601141000000_e201601141005580_AK.nc'
;fn2='/home/nadias/idl/postprocess/fixed_s201601141000000_e201601141005580_AK.nc'
;fn='/home/nadias/idl/postprocess/bug_s201601141000000_e201601141005580_AK.nc'

;fn2='/home/nadias/data/TwithO3chan_s201601141000000_e201601141005580_AK.nc'
fn2='/home/nadias/data/withO3_s201601141000000_e201601141005580_AK.nc'
fn='/home/nadias/data/noO3_s201601141000000_e201601141005580_AK.nc'

restore,'~/data/basics.sav'; pobs,nlev

plev=pobs
takplev=plev(tlev)
qakplev=plev(watlev)
ozakplev=plev(o3lev)
taknlev=n_elements(tlev)
qaknlev=n_elements(watlev)
ozaknlev=n_elements(o3lev)
cnt=0
; date
daystr='20160114'
datestr='20180114'
yy='2016';strmid(daystr,0,4)
mm='01';strmid(daystr,4,2)
dd='14';strmid(daystr,6,2)

param='T'
cmax=0.4

; data directory
ddir='~/data/'

; start plotting
loadct,20
mcolor=byte(!p.color)
if mcolor eq 0 then mcolor=255
icmm1=mcolor-1
icmm2=mcolor-2
!p.background=255.
!p.color=0
!p.thick=2.0
!p.charsize=1.5
loadct,20;33
cnt=0L
; READ NUCAPS FILES
print,fn
result=read_ncdf(fn,dat)
result=read_ncdf(fn2,dat2)
;------------------------------------------
;	s=size(dat.latitude)
	nprof=n_elements(dat.latitude)
	akmatrixt=dat.tak2; averaging kernel [10 x 10 x 30 x 4]
	akmatrixq=dat.h2oak; averaging kernel [10 x 10 x 30 x 4]
	akmatrixoz=dat.o3ak; averaging kernel [10 x 10 x 30 x 4]
	akmatrixt2=dat2.tak2; averaging kernel [10 x 10 x 30 x 4]
	akmatrixq2=dat2.h2oak; averaging kernel [10 x 10 x 30 x 4]
	akmatrixoz2=dat2.o3ak; averaging kernel [10 x 10 x 30 x 4]
        qf=dat.qcmask; [30 x 4]
        qf2=dat2.qcmask; [30 x 4]
	lats=dat.latitude; [30 x 4]
	lons=dat.longitude; [30 x 4]
help,lats
; define output array
	akoutt=fltarr(taknlev,nprof)*!Values.F_NAN
        akoutt2=fltarr(taknlev,nprof)*!Values.F_NAN
	akoutq=fltarr(qaknlev,nprof)*!Values.F_NAN
        akoutq2=fltarr(qaknlev,nprof)*!Values.F_NAN
	akoutoz=fltarr(ozaknlev,nprof)*!Values.F_NAN
        akoutoz2=fltarr(ozaknlev,nprof)*!Values.F_NAN
; subset ak for specific pressure level
	for i=0, nprof-1 do begin
		akoutt(*,i)=diag_matrix(akmatrixt(*,*,i))
		akoutt2(*,i)=diag_matrix(akmatrixt2(*,*,i))
		akoutq(*,i)=diag_matrix(akmatrixq(*,*,i))
		akoutq2(*,i)=diag_matrix(akmatrixq2(*,*,i))
		akoutoz(*,i)=diag_matrix(akmatrixoz(*,*,i))
		akoutoz2(*,i)=diag_matrix(akmatrixoz2(*,*,i))
	endfor

akoutt(where(akoutt lt -100))=!Values.F_NAN
akoutt2(where(akoutt2 lt -100))=!Values.F_NAN
akoutq(where(akoutq lt -100))=!Values.F_NAN
akoutq2(where(akoutq2 lt -100))=!Values.F_NAN
akoutoz(where(akoutoz lt -100))=!Values.F_NAN
akoutoz2(where(akoutoz2 lt -100))=!Values.F_NAN


claser, psfile='temp.eps',/eps
diff=akoutt(*,num)-akoutt2(*,num)
xmax=0.0025;max(diff)+0.0005
;
!p.multi=[0,3,1]
figtit=figdir+'ak_prof'+strtrim(num,1)+'.jpg'
; temperature
plot,akoutt(*,num),takplev,Ytitle='Pressure [hPa]',$
	xtitle='AK',/ylog,color=15,$
        yrange=yrange,xrange=[0,xmax],Title='Temperature AKs',$
        /nodata,xticklen=1.0,yticklen=1.0,ytickv=ytickv,$
        yticks=yticks,xgridstyle=1,ygridstyle=1,$
        ytickname=yticknames
for i=0,nprof-1 do begin
	if (qf(i) eq 0 and qf2(i) eq 0) then begin
	diff=akoutt(*,i)-akoutt2(*,i)
	idx=where(diff gt 0.001)
	if n_elements(idx) gt 1 then print,'haywire profile=',i
	oplot,diff,takplev,color=234,thick=2,linestyle=0
	endif
endfor
print, akoutt(*,721)
print,'=========================='
print,akoutt2(*,721)
; water vapor
diff=akoutq(*,num)-akoutq2(*,num)
;xmax=0.001;max(diff)+0.005
plot,akoutq(*,num),qakplev,Ytitle='Pressure [hPa]',$
        xtitle='AK',/ylog,color=15,$
        yrange=yrange,xrange=[0,xmax],Title='Water Vapor AKs',$
        /nodata,xticklen=1.0,yticklen=1.0,ytickv=ytickv,$
        yticks=yticks,xgridstyle=1,ygridstyle=1,$
        ytickname=yticknames
for i=0,nprof-1 do begin
	if (qf(i) eq 0 and qf2(i) eq 0) then begin
        diff=akoutq(*,i)-akoutq2(*,i)
        oplot,diff,qakplev,color=234,thick=2,linestyle=0
	endif
endfor
; ozone
diff=akoutoz(*,num)-akoutoz2(*,num)
xmax=0.0025;max(diff)+0.0005
plot,akoutoz(*,num),ozakplev,Ytitle='Pressure [hPa]',$
        xtitle='AK',/ylog,color=15,$
        yrange=yrange,xrange=[0,xmax],Title='Ozone AKs',$
        /nodata,xticklen=1.0,yticklen=1.0,ytickv=ytickv,$
	yticks=yticks,xgridstyle=1,ygridstyle=1,$
	ytickname=yticknames
for i=0,nprof-1 do begin
	if (qf(i) eq 0 and qf2(i) eq 0) then begin
        diff=akoutoz(*,i)-akoutoz2(*,i)
        oplot,diff,ozakplev,color=234,thick=2,linestyle=0
	endif
endfor
chard,/date,/nolp
cmd = 'convert -quality 100 -density 256x256 temp.eps '+figtit
spawn,cmd
print,'figure saved to '+figtit

end
