pro nsplot_ak_diag_doubleT_single,num,estr
instr='npp'
orbit='am'
xtype='clim'
tlev=[1,  8, 10, 13, 15, 19, 24, 27, 32, 36,$
      39, 43, 47, 51, 56, 61, 66, 71, 75, 80,83, 87, 92, 100]
; can't plot T AK now because the number of levels vary between 21 and 23. 
; they vary because of topography. Just shave off the bottom layers
;akfn='/iliad/proxy/nadias/nucaps/npp/2018/03/21/netcdf/nucaps_npp_am_zone1_s201803210118070_e201803210126050_AK.nc'
yrange=[1000.0,10.0]
ytickv=[1000.,850.,500.,300.,100.,50.,10.]
yticknames=['1000','850','500','300','100','50','10']
yticks=n_elements(ytickv)-1

;fn='/home/nadias/idl/postprocess/bug_s201601141000000_e201601141005580_AK.nc'
fn='/home/nadias/idl/postprocess/fixed_s201601141000000_e201601141005580_AK.nc'
restore,'~/data/basics.sav'; pobs,nlev

plev=pobs
akplev=plev(tlev)
aknlev=n_elements(tlev)
cnt=0
; date
daystr='20160114'
datestr='20180114'
yy='2016';strmid(daystr,0,4)
mm='01';strmid(daystr,4,2)
dd='14';strmid(daystr,6,2)

param='T'
cmax=0.4

xtitle='Temperature Averaging Kernel'

; data directory
ddir='~/data/'

; start plotting
claser,psfile="unc.eps",/eps
loadct,20
mcolor=byte(!p.color)
if mcolor eq 0 then mcolor=255
icmm1=mcolor-1
icmm2=mcolor-2
!p.background=255.
!p.color=0
!p.thick=2.0
!p.charsize=1.5
loadct,20;33
cnt=0L
; READ NUCAPS FILES
print,fn
result=read_ncdf(fn,dat)
help,dat
;------------------------------------------
;	s=size(dat.latitude)
	nprof=n_elements(dat.latitude)
	akmatrix=dat.tak; averaging kernel [10 x 10 x 30 x 4]
	akmatrix2=dat.tak2; averaging kernel [10 x 10 x 30 x 4]
        qf=dat.qcmask; [30 x 4]
	lats=dat.latitude; [30 x 4]
	lons=dat.longitude; [30 x 4]
help,lats
; define output array
	 akout=fltarr(aknlev,nprof)*!Values.F_NAN
        akout2=fltarr(aknlev,nprof)*!Values.F_NAN
; subset ak for specific pressure level
	for i=0, nprof-1 do begin
		akout(*,i)=diag_matrix(akmatrix(*,*,i))
		akout2(*,i)=diag_matrix(akmatrix2(*,*,i))
	endfor

akout(where(akout lt -100))=!Values.F_NAN
akout2(where(akout2 lt -100))=!Values.F_NAN

claser, psfile='temp.eps',/eps
!p.multi=[0,3,1]
xrange=[0.0,0.25]
figtit=estr+'_test.jpg'
plot,akout(*,num),akplev,Ytitle='Pressure [hPa]',$
	xtitle='AK',/ylog,$
        yrange=yrange,xrange=xrange,Title='T AKs',$
        /nodata,xticklen=1.0,yticklen=1.0,ytickv=ytickv,$
        yticks=yticks,xgridstyle=1,ygridstyle=1,$
        ytickname=yticknames
oplot,akout(*,num),akplev,color=234,thick=3,linestyle=0
oplot,akout2(*,num),akplev,color=145,thick=3,linestyle=0
num=num+100
plot,akout(*,num),akplev,Ytitle='Pressure [hPa]',$
	xtitle='AK',/ylog,$
        yrange=yrange,xrange=xrange,Title='T AKs',$
        /nodata,xticklen=1.0,yticklen=1.0,ytickv=ytickv,$
        yticks=yticks,xgridstyle=1,ygridstyle=1,$
        ytickname=yticknames
oplot,akout(*,num),akplev,color=234,thick=3,linestyle=0
oplot,akout2(*,num),akplev,color=145,thick=3,linestyle=0
num=num+100
plot,akout(*,num),akplev,Ytitle='Pressure [hPa]',$
	xtitle='AK',/ylog,$
        yrange=yrange,xrange=xrange,Title='T AKs',$
        /nodata,xticklen=1.0,yticklen=1.0,ytickv=ytickv,$
        yticks=yticks,xgridstyle=1,ygridstyle=1,$
        ytickname=yticknames
oplot,akout(*,num),akplev,color=234,thick=3,linestyle=0
oplot,akout2(*,num),akplev,color=145,thick=3,linestyle=0
chard,/date,/nolp
cmd = 'convert -quality 100 -density 256x256 temp.eps '+figtit
spawn,cmd
print,'figure saved to '+figtit

end
