; script by Nadia to read RAQMSi
pro nsplot_ak_map

idxak=[4, 5, 6, 7]; [100, 150, 200, 300]

o3plev=[0.026,22.16,53.79,74.35,106.586,146.781,217.685,307.015,606.847,1085.40]
akplev=o3plev(idxak)
aknlev=n_elements(akplev)
pidx=idxak(3)
; date
daystr='20170219'
datestr='20170219'
yy='2017';strmid(daystr,0,4)
mm='02';strmid(daystr,4,2)
dd='19';strmid(daystr,6,2)

orbit='pm'
param='O3'

; data directory
ddir='/iliad/proxy/nadias/nucaps/npp/2017/ATom/02/19/ak_nc'

; output figure name
jname='nucaps_'+param+'_AK_'+datestr+'_'+strtrim(floor(o3plev(pidx)),1)+'hPa_'+orbit+'.jpg'

; plotting values
; geographic limits
usalim=[20,-130,60,-65]; [minlat,minlon,maxlat,maxlon]
globlim=[-90,-180,90,180]
canada=[30,-130,65,-65];[50,-120,68,-85]
florida=[20,-95,40,-70]
print,ddir
wideus=[20,-130,65,-50]
latlon=globlim

if latlon(0) eq -90 then symsize=.1
if latlon(0) gt -90 then symsize=0.55;1.0;.55

minlat=latlon(0)
minlon=latlon(1)
maxlat=latlon(2)
maxlon=latlon(3)
numcol=10
coltitle='[%]'
tformat='(i3)'
titoffset=0.001
title='NUCAPS O3 AK at '+strtrim(floor(o3plev(pidx)),1)+' hPa '+datestr+' '+strupcase(orbit)+' orbit'

; find all the files to plot
filespec=ddir+'/NUCAPS-EDR_'+param+'_'+orbit+'_*'+datestr+'*.nc'
filelist=findfile(filespec)
nfiles=n_elements(filelist)
print,nfiles+' files to process'

; start plotting
claser,psfile="unc.eps",/eps
loadct,20
mcolor=byte(!p.color)
if mcolor eq 0 then mcolor=255
icmm1=mcolor-1
icmm2=mcolor-2
!p.background=255.
!p.color=0
!p.thick=2.0
!p.charsize=1.5
loadct,20;33
;; reverse color table
;tvlct,r,g,b,/get
;rr=reverse(r)
;gg=reverse(g)
;bb=reverse(b)
;tvlct,rr,gg,bb

dx=250/(numcol-1)
ncol=(numcol-1)*dx+1

;xcol=!color.red
;red=[xcol(0),xcol(1),xcol(2)]
;red=reform(red,1,3)
;tvlct,red,ncol+1

rejclear=0
clearsky=0
for n=0,nfiles-1 do begin
    	print, 'reading file', filelist(n)
	result=read_ncdf(filelist(n),dat)
;------------------------------------------
print,filelist(n)	
	s=size(dat.alat)
	nprof=s(1)
	nscan=s(2)
	akmatrix=dat.ak; averaging kernel [10 x 10 x 30 x 4]
        qf=dat.qcmask; [30 x 4]
	lats=dat.alat; [30 x 4]
	lons=dat.alon; [30 x 4]
	aklev=fltarr(nprof,nscan)
; subset ak for specific pressure level
	for i=0,nprof-1 do begin
	for j=0,nscan-1 do begin
	        ak=reform(diag_matrix(akmatrix(*,*,i,j)))
		if qf(i,j) eq 0 then aklev(i,j)=ak(pidx) 
	endfor
	endfor
	
	imin=min(aklev)
	imax=max(aklev)
	print,imin,imax

	lats=reform(lats,nprof*nscan)
	lons=reform(lons,nprof*nscan)
	aklev=reform(aklev,nprof*nscan)

	idx=where(aklev lt 0,count)
	if (count gt 0) then aklev(idx)=!VALUES.F_NAN

	if n eq 0 then begin
        set_viewport,.08,.78,.1,.95
	   if latlon(0) eq -90 then begin 
		map_set,/robinson,/horizon,/isotropic,$
 		/continents,limit=[minlat,minlon,maxlat,maxlon]
	   endif else begin
                map_set,/miller_cylindrical,/horizon,/isotropic,$
                /continents,limit=[minlat,minlon,maxlat,maxlon]
	   endelse
; Define circle as symbol to plot
		a=findgen(17)*(2*!pi/16.)
		usersym,cos(a),sin(a),/fill
		color=bytscl(aklev,min=imin,max=imax,top=ncol+1.,/NAN)
		help,color
		cindex=where(color lt 0)
		if cindex(0) ne -1 then color(cindex)=0B
;cindex=where(color gt icmm2)
;if cindex(0) ne -1 then color(cindex)=icmm2
		!psym=8 ;circle
		plots,lons,lats,symsize=symsize,color=color
	endif else begin
		color=bytscl(aklev,min=imin,max=imax,top=ncol+1.,/NAN)
		help,color
		cindex=where(color lt 0)
		if cindex(0) ne -1 then color(cindex)=0B
;cindex=where(color gt icmm2)
;if cindex(0) ne -1 then color(cindex)=icmm2
		!psym=8
		plots,lons,lats,symsize=symsize,color=color
	endelse

	if n eq nfiles-1 then begin

;	title=title+' (max='+string(maxval,format='(f3.1)')+')'

	xcol=!color.black
	black=[xcol(0),xcol(1),xcol(2)]
	black=reform(black,1,3)
	tvlct,black,255
       ; xcol=!color.white
       ; white=[xcol(0),xcol(1),xcol(2)]
       ; white=reform(white,1,3)
       ; tvlct,white,2
	!psym=0
	!p.thick=1.5
	!p.color=255B
	dx=(imax-imin)/float(ncol)
	rlevels=imin+findgen(ncol+1)*dx
	rcolors=2+indgen(ncol)
	;print,rcolors
	dx=(ncol)/(numcol-1)
	levs=fltarr(numcol)
	test=fltarr(numcol-1)*dx
	levs(0:numcol-2)=test
	levs(numcol-1)=levs(numcol-2)+dx
	colorbar1,rlevels,rcolors,/col,charsize=.9,format=tformat,/right,$
	  unit=coltitle,xsize=0.017,lowleft=[0.1,0.84],$
	  /noframe,levelind=levs,/ivestyle,loffset=0.05,uoffset=0.05

	if latlon(0) eq -90 then begin
             map_set,/robinson,limit=[minlat,minlon,maxlat,maxlon],$
             color=255B,/isotropic,/noerase,/horizon
		;/grid,latdel=20,londel=40,/label,lonlab=minlat,latlab=minlon,$
	     ;/horizon,charsize=0.7,/isotropic,/noerase
             map_continents,/coasts,color=255B
	endif else begin
             map_set,/miller_cylindrical,limit=[minlat,minlon,maxlat,maxlon],$
             /isotropic,color=255B,/grid,latdel=10,londel=20,/noerase
       	     map_continents,/coasts,/USA,color=255B
	endelse
	endif
endfor

; figure title
;     xyouts,!x.window[0]+titoffset,!y.window[1]+0.025,title,/norm,charsize=1
;chard,/nolp
;cmd='convert -density 200x200 -quality 120 unc.eps ' + jname
;spawn,cmd
;print,'figure saved to '+jname
end
