pro find_surface,pres,psurf,surflev,iobs
; input:
;    pres = pressure array
;    surfpres = surface pressure at single footprint
; output:
;    surflev = array index at which pressure array value is closest to surface pressure

; find the index of pressure level closest to Psurf
;    diff = abs(pres - surfpres)
;    clev = where(diff eq min(diff))

     phigh = 1100.
     plow = 100.

; 5.0 hPa is the amount of uncertainty about the surface level we allow
;    threshold = surfpres - pres(clev-1)
;    if threshold ge 5.0 then surflev = clev
;    if threshold lt 5.0 then print,iobs
     nlev=n_elements(pres)-1
     if (psurf gt plow and psurf le phigh) then begin
       for L=nlev, 0 , -1 do begin
          if (psurf ge pres(L-1)+5.0) then begin
           surflev = L	
           break 
          endif
       endfor
     endif else begin
	print,'Surface pressure outside range for observation #',iobs
     endelse
         
      

;    if (surfpres lt pres(clev)) and (min(diff) gt 5.0) then surflev = clev
;    if (surfpres gt pres(clev)) and (min(diff) le 5.0) then surflev = clev 
;    if (surfpres gt pres(clev)) and (min(diff) gt 5.0) then surflev = clev + 1 

end

