pro read_caps_ak,infn,ak

; Nadia Smith
; 29 July 2019
; nadias@stcnet.com

; water pressure layers of AK
;    0.0256546      74.3533      175.001      279.537      321.352      351.237      415.914
;      525.416      628.263      718.162      865.640     -9999.00

; ----------------------------------------
; Read NUCAPS netcdf file
; ----------------------------------------
  flag = read_ncdf(infn,nucaps)

;   LATITUDE        FLOAT     Array[1800]
;   LONGITUDE       FLOAT     Array[1800]
;   TSURF           FLOAT     Array[1800]
;   LANDFRAC        FLOAT     Array[1800]
;   VIEWANGLE       FLOAT     Array[1800]
;   SOLZANG         FLOAT     Array[1800]
;   H2OAK           FLOAT     Array[12, 12, 1800]
;   O3AK            FLOAT     Array[10, 10, 1800]
;   COAK            FLOAT     Array[10, 10, 1800]
;   CH4AK           FLOAT     Array[12, 12, 1800]
;   H2ODOF          FLOAT     Array[1800]
;   O3DOF           FLOAT     Array[1800]
;   CODOF           FLOAT     Array[1800]
;   CH4DOF          FLOAT     Array[1800]
;   QCMASK          LONG      Array[1800]

  if flag eq 1 then begin
     nobs = n_elements(nucaps.latitude); number of observations
     print,'Number of retrievals to process: ',nobs
     ak = {one, akh2o:fltarr(12,nobs), ako3:fltarr(10,nobs), akco:fltarr(10,nobs), $
	dofo3trop:fltarr(nobs), dofo3strat:fltarr(nobs), $
	dofh2obnd:fltarr(nobs), dofh2omid:fltarr(nobs), dofh2otop:fltarr(nobs)}

	for i=0,nobs-1 do begin
		ak.akh2o(*,i) = diag_matrix(reform(nucaps.h2oak(*,*,i)))
		ak.ako3(*,i) = diag_matrix(reform(nucaps.o3ak(*,*,i)))
		ak.akco(*,i) = diag_matrix(reform(nucaps.coak(*,*,i)))
		ak.ako3(where(ak.ako3 lt 0))=!values.f_nan
		ak.akh2o(where(ak.akh2o lt 0))=!values.f_nan
		ak.akco(where(ak.akco lt 0))=!values.f_nan
	
  		ak.dofo3trop(i)=total(ak.ako3(6:8,i),/nan); 217.69, 307, 606 (not including 1085) 
  		ak.dofo3strat(i)=total(ak.ako3(0:5,i),/nan); 0.026, 22, 53, 74, 106, 146 
	        ak.dofh2obnd(i)=total(ak.akh2o(10:11,i),/nan);  865,1085
		ak.dofh2omid(i)=total(ak.akh2o(6:9,i),/nan);415,525,628,718
		ak.dofh2otop(i)=total(ak.akh2o(2:5,i),/nan); 175,279,321,351
	endfor
  endif else begin
     print,'No such file exists'
     stop
  endelse
end
