pro space_gridding,ngrid,infn

        FILL_VAL=-9999.
; Combine files together in one large array

; This routine sets all these variables according the the value of "ngrid"
        call_res, ngrid, start_lat, end_lat, start_lon, end_lon, lat_inc, lon_inc, grid_res, nlatbins, nlonbins, minsample

; read input file
	out=read_ncdf(infn,caps)
        lat_daily=caps.latitude
	lon_daily=caps.longitude
;
	ctp=caps.ctp; clout top pressure
	cfrac=caps.cfrac; clout top fraction
	eta=caps.eta; cloud clearing residual
	tdof=caps.tdof; degrees of freedom
	ampl=caps.ampl; cloud clearing noise amplification factor
	tropT=caps.tropT; tropopause temperature
	tropP=caps.tropP; tropopause pressure
	plev=caps.pressure
	nlev=n_elements(plev)
; define grid arrays
; grid_res=nlat*nlon
	T_mu = fltarr(nlev,grid_res)+FILL_VAL; 
	T_median = fltarr(nlev,grid_res)+FILL_VAL; 
	T_sigma = fltarr(nlev,grid_res)+FILL_VAL

	Tdof_mu = fltarr(grid_res)+FILL_VAL; 
	Tdof_sigma = fltarr(grid_res)+FILL_VAL; 
	
        Q_mu = fltarr(nlev,grid_res)+FILL_VAL; 
        Q_sigma = fltarr(nlev,grid_res)+FILL_VAL; 
	Qdof_mu = fltarr(grid_res)+FILL_VAL; 
	Qdof_sigma = fltarr(grid_res)+FILL_VAL; 

        O3_mu = fltarr(nlev,grid_res)+FILL_VAL; 
        O3_sigma = fltarr(nlev,grid_res)+FILL_VAL; 
	O3dof_mu = fltarr(grid_res)+FILL_VAL; 
	O3dof_sigma = fltarr(grid_res)+FILL_VAL; 

	CO_mu = fltarr(nlev,grid_res)+FILL_VAL; 
        CO_sigma = fltarr(nlev,grid_res)+FILL_VAL; 
	COdof_mu = fltarr(grid_res)+FILL_VAL; 
	COdof_sigma = fltarr(grid_res)+FILL_VAL; 


;	ctp_mu=fltarr(grid_res)+FILL_VAL
;	ctp_sigma=fltarr(grid_res)+FILL_VAL

	cfrac_mu=fltarr(grid_res)+FILL_VAL
	cfrac_sigma=fltarr(grid_res)+FILL_VAL

	eta_mu = fltarr(grid_res)+FILL_VAL; 
	eta_sigma=fltarr(grid_res)+FILL_VAL; 

	ampl_mu=fltarr(grid_res)+FILL_VAL; 
	ampl_sigma=fltarr(grid_res)+FILL_VAL; 
;
	tropT_mu=fltarr(grid_res)+FILL_VAL; 
	tropT_sigma=fltarr(grid_res)+FILL_VAL; 

	tropP_mu=fltarr(grid_res)+FILL_VAL; 
	tropP_sigma=fltarr(grid_res)+FILL_VAL; 
	
	sample_size = fltarr(grid_res)+FILL_VAL
	glob_lat = fltarr(grid_res)
	glob_lon = fltarr(grid_res)
	
	anm = 0.0

; --------------
; Latitudinal histogram on Level 2 netcdf file
; --------------
	hist_lat = histogram(lat_daily,min=start_lat,max=end_lat+lat_inc,binsize=lat_inc,reverse_indices=ri_lat)

	for ii = 0,nlatbins-1 do begin; nlatbin comes from call_res.pro

; This condition happens when the histogram bins are empty; i.e., when the histogram range (min/max) is larger than the data range.
; You only need one of the sets of lat/longs to define the global lat/lon grids 

                   if(ri_lat[ii+1]-1 le ri_lat[ii]) then begin
; If there are empty bins, then fill the global lat/lon arrays with valid data and EXIT THE LOOP 
                             for jj = 0, nlonbins-1  do begin
                                     glob_lat[anm] = start_lat+(lat_inc/2.0)+ii*lat_inc
                                     glob_lon[anm] = start_lon+(lon_inc/2.0)+jj*lon_inc
                                     anm = anm + 1.0
                             endfor
                             goto, crap
                   endif
; Now you need to calculate the statistics for the gridded subsets of data as defined by the histogram bins
; According to http://www.faculty.virginia.edu/rwoclass/astr511/IDLresources/histogram_tutorial-JDSmith.html
; ri[ri[i]:ri[i]-1] will give you the range of indices for each subset. 

; The logic followed here is that you first do the latitude histogram and subsequent subset selection, 
;    then you do the longitude histogram on the latitudinal subset. 

; ---------------
; Create Latitudinal Subsets
; --------------

		lat_bin_index = ri_lat[ri_lat[ii]:ri_lat[ii+1]-1]
		lat_subset = lat_daily(lat_bin_index)
		lon_subset = lon_daily(lat_bin_index)
		tair = caps.temperature(*,lat_bin_index)
		qmr = caps.h2o_mr(*,lat_bin_index)
		comr = caps.co_mr(*,lat_bin_index)
		o3mr = caps.o3_mr(*,lat_bin_index)
		tdof=caps.tdof(lat_bin_index)
		qdof=caps.qdof(lat_bin_index)
		o3dof=caps.o3dof(lat_bin_index)
		codof=caps.codof(lat_bin_index)
;		ctp=ctp(lat_bin_index)
		cfrac=caps.cfrac(lat_bin_index)
		eta=caps.eta(lat_bin_index)
		ampl=caps.ampl(lat_bin_index)
		tropT=caps.tropT(lat_bin_index)
		tropP=caps.tropP(lat_bin_index)

		hist_lon = histogram(lon_subset,min=start_lon,max=end_lon+lon_inc,binsize=lon_inc,reverse_indices=ri_lon)
; The first nlonbins-1 of the ri_lon array references the [nlonbins:anum_nfovs] of ri_lon
; You, therefore, do not need to loop through the entire ri_lon array
                for jj = 0, nlonbins-1  do begin
; test if lon-bins are empty
                       if(ri_lon[jj] ne ri_lon[jj+1]) then begin  
	                     	lon_bin_index = ri_lon[ri_lon[jj]:ri_lon[jj+1]-1]
; ------------Data Filtering Step------------
; NUCAPS QC=0 means "Best" IR/MW retrieval
; viewangle < scanlimit filters retrievals based on the scan angle. 
; Sanlimit=[0.-5.] keeps only nadir retrievals, scanlimit=32. keeps near-nadir retrievals and scanlimit=60. keeps all retrievals
; -------------------------------------------	
				idxgood=where(tdof(lon_bin_index) gt 0)
; Do statistics on minimum sample, which is calculated as 30% of the total FOR per grid cell (see call_res.pro below for details). 
; minsample varies per grid resolution. This keeps geostatistics consistent across scales.                                                      
minsample=1
				if(n_elements(idxgood) ge minsample) then begin
					sample_size(anm)=n_elements(idxgood)
					
; degrees of freedom
					result=moment(tdof(lon_bin_index(idxgood)))
					tdof_mu(anm)=result[0]; average
					tdof_sigma(anm)=result[1]^0.5; stdev

					result=moment(o3dof(lon_bin_index(idxgood)))
					o3dof_mu(anm)=result[0]; average
					o3dof_sigma(anm)=result[1]^0.5; stdev

					result=moment(codof(lon_bin_index(idxgood)))
					codof_mu(anm)=result[0]; average
					codof_sigma(anm)=result[1]^0.5; stdev

					result=moment(qdof(lon_bin_index(idxgood)))
					qdof_mu(anm)=result[0]; average
					qdof_sigma(anm)=result[1]^0.5; stdev

; cloud fraction
					result=moment(cfrac(lon_bin_index(idxgood)))
					cfrac_mu(anm)=result[0];
					cfrac_sigma(anm)=result[1]^0.5

; cloud top temperature
;					result=moment(ctp(lon_bin_index(idxgood)))
;					ctp_mu=result[0]
;					ctp_sigma=result[1]^0.5
;; cc residual error
					result=moment(eta(lon_bin_index(idxgood)))
					eta_mu(anm)=result[0]
					eta_sigma(anm)=result[1]^2
;; cc amplification
					result=moment(ampl(lon_bin_index(idxgood)))
					ampl_mu(anm)=result[0]
					ampl_sigma(anm)=result[1]^0.5
;; tropopause temperature
					result=moment(tropT(lon_bin_index(idxgood)))
					tropT_mu(anm)=result[0]
					tropT_sigma(anm)=result[1]^0.5
;; tropopause pressure
					result=moment(tropP(lon_bin_index(idxgood)))
					tropP_mu(anm)=result[0]
					tropP_sigma(anm)=result[1]^0.5
; temperature profile
					for ilev=0,nlev-1 do begin
						result=Moment(tair(ilev,lon_bin_index(idxgood)))
						T_mu(ilev,anm)=result[0]; average
	;					T_median(ilev,anm)=median(tair(ilev,lon_bin_index(idxgood))); 
						T_sigma(ilev,anm)=result[1]^0.5; standard deviation is sqrt of variance
					endfor
				endif
			endif
			glob_lat[anm] = start_lat+(lat_inc/2.0)+ii*lat_inc
			glob_lon[anm] = start_lon+(lon_inc/2.0)+jj*lon_inc
			anm = anm + 1.0
			;print,anm,glob_lat[anm-1.0],glob_lon[anm-1.0],start_lat,lat_inc,start_lon,lon_inc,ii,jj
		endfor
		crap:
		; do nothing
	endfor
print,'output',Tdof_mu(1:100)
	gres=fix(grid_res)
	cdfid=ncdf_create(infn,/clobber)
	latlonid=ncdf_dimdef(cdfid,'LatxLon',gres)
	levid=ncdf_dimdef(cdfid,'plev',nlev)
; lat/lon
	varid=ncdf_vardef(cdfid,'Latitude',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, glob_lat
        ncdf_control, cdfid, /redef
        varid=ncdf_vardef(cdfid,'Longitude',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, glob_lon
        ncdf_control, cdfid, /redef
; temperature degrees of freedom 
        varid=ncdf_vardef(cdfid,'Tdof_mu',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, Tdof_mu
        ncdf_control, cdfid, /redef
        varid=ncdf_vardef(cdfid,'Tdof_sigma',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, Tdof_sigma
        ncdf_control, cdfid, /redef
; h2o degrees of freedom 
        varid=ncdf_vardef(cdfid,'Qdof_mu',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, Qdof_mu
        ncdf_control, cdfid, /redef
        varid=ncdf_vardef(cdfid,'Qdof_sigma',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, Qdof_sigma
        ncdf_control, cdfid, /redef
; o3 of freedom 
        varid=ncdf_vardef(cdfid,'o3dof_mu',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, O3dof_mu
        ncdf_control, cdfid, /redef
        varid=ncdf_vardef(cdfid,'o3dof_sigma',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, O3dof_sigma
        ncdf_control, cdfid, /redef
; co of freedom 
        varid=ncdf_vardef(cdfid,'codof_mu',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, COdof_mu
        ncdf_control, cdfid, /redef
        varid=ncdf_vardef(cdfid,'codof_sigma',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, COdof_sigma
        ncdf_control, cdfid, /redef
; tropopause temperature 
        varid=ncdf_vardef(cdfid,'tropT_mu',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, tropT_mu
        ncdf_control, cdfid, /redef
        varid=ncdf_vardef(cdfid,'tropT_sigma',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, tropT_sigma
        ncdf_control, cdfid, /redef
; tropopause pressure
        varid=ncdf_vardef(cdfid,'tropP_mu',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, tropP_mu
        ncdf_control, cdfid, /redef
        varid=ncdf_vardef(cdfid,'tropP_sigma',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, tropP_sigma
        ncdf_control, cdfid, /redef
; cloud top pressure mean
;        varid=ncdf_vardef(cdfid,'ctp_mu',[latlonid],/float)
;        ncdf_control, cdfid, /endef
;        ncdf_varput, cdfid, varid, ctp_mu
;        ncdf_control, cdfid, /redef
;        varid=ncdf_vardef(cdfid,'ctp_sigma',[latlonid],/float)
;        ncdf_control, cdfid, /endef
;        ncdf_varput, cdfid, varid, ctp_sigma
;        ncdf_control, cdfid, /redef
;; cloud fraction mean
        varid=ncdf_vardef(cdfid,'cfrac_mu',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, cfrac_mu
        ncdf_control, cdfid, /redef
        varid=ncdf_vardef(cdfid,'cfrac_sigma',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, cfrac_sigma
        ncdf_control, cdfid, /redef
;; cloud clearing residual error
        varid=ncdf_vardef(cdfid,'eta_mu',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, eta_mu
        ncdf_control, cdfid, /redef
        varid=ncdf_vardef(cdfid,'eta_sigma',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, eta_sigma
        ncdf_control, cdfid, /redef
;; cloud clearing amplification factor
        varid=ncdf_vardef(cdfid,'ampl_mu',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, ampl_mu
        ncdf_control, cdfid, /redef
        varid=ncdf_vardef(cdfid,'ampl_sigma',[latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, ampl_sigma
        ncdf_control, cdfid, /redef
; Temperature mean
	varid=ncdf_vardef(cdfid,'T_mu',[levid,latlonid],/float)
	ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, T_mu
        ncdf_control, cdfid, /redef
; Temperature median
	varid=ncdf_vardef(cdfid,'T_median',[levid,latlonid],/float)
	ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, T_median
        ncdf_control, cdfid, /redef
; Temperature standard deviation
        varid=ncdf_vardef(cdfid,'T_sigma',[levid,latlonid],/float)
        ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, T_sigma
        ncdf_control, cdfid, /redef
; H2O mean
	varid=ncdf_vardef(cdfid,'Q_mu',[levid,latlonid],/float)
	ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, Q_mu
        ncdf_control, cdfid, /redef
; O3 mean
	varid=ncdf_vardef(cdfid,'O3_mu',[levid,latlonid],/float)
	ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, O3_mu
        ncdf_control, cdfid, /redef
; CO mean
	varid=ncdf_vardef(cdfid,'CO_mu',[levid,latlonid],/float)
	ncdf_control, cdfid, /endef
        ncdf_varput, cdfid, varid, CO_mu
        ncdf_close,cdfid
end


; =======================================================
; *******************************************************
; =======================================================

PRO  call_res, ngrid, start_lat, end_lat, start_lon, end_lon, lat_inc, lon_inc, grid_res, nlatbins, nlonbins,minsample
; The argument for the minsample definition is as follows:
;   1.5deg = ~150km = 3 x 50km along one axis and 3 x 3 = 9 FOVs per grid cell
;   2deg = ~200km = 4 x 50km...16 FOVs
;   3deg = ~300km = 6 x 50km...36 FOVs
;   4deg = ~400km = 8 x 50km...64 FOVs
;   6deg = ~600km = 12 x 50km...144 FOVs
;   12deg = ~1200km = 24 x 50km...576 FOVs
;   minsample is 30% of total. This is high given that I concluded that the minimum
; sample size should be ... what did I say in that paper? 

  if(ngrid eq 1) then begin  ; 1.5x1.5 deg res
       start_lat = -90.0
       end_lat = 88.5
       start_lon = -180.0
       end_lon = 178.5
       lat_inc = 1.5
       lon_inc = 1.5
       nlatbins = 120
       nlonbins = 240
       grid_res = 120.0*240.0
       minsample = 3
  endif

  if(ngrid eq 2) then begin  ; 2x2 deg res
       start_lat = -90.0
       end_lat = 88.0
       start_lon = -180.0
       end_lon = 178.0
       lat_inc = 2.0
       lon_inc = 2.0
       nlatbins = 90
       nlonbins = 180
       grid_res = 90.0*180.0
       minsample = 5
  endif
  if(ngrid eq 3) then begin  ; 3x3 deg res
       start_lat = -90.0
       end_lat = 87.0
       start_lon = -180.0
       end_lon = 177.0
       lat_inc = 3.0
       lon_inc = 3.0
       nlatbins = 60
       nlonbins = 120
       grid_res = 60.0*120.0
       minsample = 11
  endif

  if(ngrid eq 4) then begin  ; 4x4 deg res
       start_lat = -90.0
       end_lat = 86.0
       start_lon = -180.0
       end_lon = 176.0
       lat_inc = 4.0
       lon_inc = 4.0
       nlatbins = 45
       nlonbins = 90
       grid_res = 45.0*90.0
       minsample = 24
  endif

  if(ngrid eq 5) then begin  ; 6x6 deg res
       start_lat = -90.0
       end_lat = 84.0
       start_lon = -180.0
       end_lon = 174.0
       lat_inc = 6.0
       lon_inc = 6.0
       nlatbins = 30
       nlonbins = 60
       grid_res = 30.0*60.0
       minsample = 43
  endif

  if(ngrid eq 6) then begin  ; 12x12 deg res
       start_lat = -90.0
       end_lat = 78.0
       start_lon = -180.0
       end_lon = 168.0
       lat_inc = 12.0
       lon_inc = 12.0
       nlatbins = 15
       nlonbins = 30
       grid_res = 15.0*30.0
       minsample = 176
  endif

end
