;pro write_ncdf, outfn, nucaps, stdT, stdrelhum, stdozmr, t2m, rh2m,totwat,totoz, stdplev, wvcd, stdwvmr
pro write_ncdf,outfn,stdplev,plat,plon,stdT,ctp,$
   cfrac,tropT,tropP,eta,ampl,tdof,$
   stdQmr,stdCOmr,stdO3mr,qdof,codof,o3dof,o3doftrop,o3dofstrat,$
        h2odofbnd,h2odofmid,h2odoftop 

; write parameters stdT, temp2m, lat, lon, stdplev to netcdf file
; outfn = filename with full path
; 
  nfov = n_elements(plat)
  nlev = n_elements(stdplev)

; Create and set up output file
  ncid = ncdf_create(outfn,/clobber)
  nfovid = ncdf_dimdef(ncid,'Number of Retrievals', nfov)
  nlevid = ncdf_dimdef(ncid, 'Number of Pressure Levels',nlev)

; Latitude 
  varid = ncdf_vardef(ncid,'Latitude',[nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, plat
  ncdf_control, ncid, /redef

; Longitude
  varid = ncdf_vardef(ncid,'Longitude',[nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, plon
  ncdf_control, ncid, /redef

; Pressure [hPa]
  varid = ncdf_vardef(ncid,'Pressure',[nlevid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, stdplev
  ncdf_control, ncid, /redef

; cloud top pressure
  varid = ncdf_vardef(ncid,'ctp',[nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, ctp
  ncdf_control, ncid, /redef

; cloud fraction
  varid = ncdf_vardef(ncid,'cfrac',[nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, cfrac
  ncdf_control, ncid, /redef

; cloud clearing residual
  varid = ncdf_vardef(ncid,'eta',[nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, eta
  ncdf_control, ncid, /redef

; cloud clearing amplification factor
  varid = ncdf_vardef(ncid,'ampl',[nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, ampl
  ncdf_control, ncid, /redef

; tropopause temperature
  varid = ncdf_vardef(ncid,'tropT',[nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, tropT
  ncdf_control, ncid, /redef

; tropopause pressure
  varid = ncdf_vardef(ncid,'tropP',[nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, tropP
  ncdf_control, ncid, /redef

; temperature degrees of freedom
  varid = ncdf_vardef(ncid,'tdof',[nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, tdof
  ncdf_control, ncid, /redef

; water vapor  degrees of freedom
  varid = ncdf_vardef(ncid,'qdof',[nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, qdof
  ncdf_control, ncid, /redef

; boundary layer water vapor  degrees of freedom
  varid = ncdf_vardef(ncid,'h2odofbnd',[nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, h2odofbnd
  ncdf_control, ncid, /redef

; mid-layer water vapor  degrees of freedom
  varid = ncdf_vardef(ncid,'h2odofmid',[nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, h2odofmid
  ncdf_control, ncid, /redef

; upper troposphere water vapor  degrees of freedom
  varid = ncdf_vardef(ncid,'h2odoftop',[nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, h2odoftop
  ncdf_control, ncid, /redef
; carbon monoxide degrees of freedom
  varid = ncdf_vardef(ncid,'codof',[nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, codof
  ncdf_control, ncid, /redef

; ozone degrees of freedom
  varid = ncdf_vardef(ncid,'o3dof',[nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, o3dof
  ncdf_control, ncid, /redef

; tropospheric ozone degrees of freedom
  varid = ncdf_vardef(ncid,'o3doftrop',[nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, o3doftrop
  ncdf_control, ncid, /redef

; stratospheric ozone degrees of freedom
  varid = ncdf_vardef(ncid,'o3dofstrat',[nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, o3dofstrat
  ncdf_control, ncid, /redef
; 2m Temperature [K]
;  varid = ncdf_vardef(ncid,'TMP2m',[nfovid],/float)
;  ncdf_control, ncid, /endef
;  ncdf_varput, ncid, varid, t2m
;  ncdf_control, ncid, /redef

; 2m Relative Humidity [%]
;  varid = ncdf_vardef(ncid,'RH2m',[nfovid],/float)
;  ncdf_control, ncid, /endef
;  ncdf_varput, ncid, varid, rh2m
;  ncdf_control, ncid, /redef

; Total precipitable water [cm]
;  varid = ncdf_vardef(ncid,'totwat',[nfovid],/float)
;  ncdf_control, ncid, /endef
;  ncdf_varput, ncid, varid, totwat
;  ncdf_control, ncid, /redef

; Total ozone [DU]
;  varid = ncdf_vardef(ncid,'O3DU',[nfovid],/float)
;  ncdf_control, ncid, /endef
;  ncdf_varput, ncid, varid, totoz
;  ncdf_control, ncid, /redef

; Profile Relative Humidity [%]
;  varid = ncdf_vardef(ncid,'Relative_Humidity',[nlevid,nfovid],/float)
;  ncdf_control, ncid, /endef
;  ncdf_varput, ncid, varid, stdrelhum
;  ncdf_control, ncid, /redef

; Profile O3 volume mixing ratio [ppb]
  varid = ncdf_vardef(ncid,'O3_MR',[nlevid,nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid,stdO3mr
  ncdf_control, ncid, /redef

; Profile CO volume mixing ratio [ppb]
  varid = ncdf_vardef(ncid,'CO_MR',[nlevid,nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid,stdCOmr
  ncdf_control, ncid, /redef

; Profile Temperature [K]
  varid = ncdf_vardef(ncid,'Temperature',[nlevid,nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, stdT
  ncdf_control, ncid, /redef

; Water vapor mixing ratio [g/kg]
  varid = ncdf_vardef(ncid,'H2O_MR',[nlevid,nfovid],/float)
  ncdf_control, ncid, /endef
  ncdf_varput, ncid, varid, stdQmr
  ncdf_control, ncid, /redef

; H2O column density
;  varid = ncdf_vardef(ncid,'H2O',[nlevid,nfovid],/float)
;  ncdf_control,ncid,/endef
;  ncdf_varput,ncid,varid,wvcd
;
  ncdf_close,ncid

  print, 'Values written to ',outfn

end

