pro nsplot_stgrid_global_AK_diff,xtype,iparam,orbit,sattype1,sattype2,datestr
; 
; param='air_temp','h2o_vap','o3'

jname='test.jpg'
!except=0

paramlist=['air_temp','h2o_vap','o3','co','ch4','co2','hno3']
xnamelist=['T','H!I2!NO','O!I3!N','CO','CH!I4!N','CO!I2!N','HNO!I3!N']
param=paramlist(iparam)
xtit=xnamelist(iparam)

gidx=1
if gidx eq 1 then gridarr=[1.5,240,120];[gsize,nlon, nlat] 1.5deg
if gidx eq 2 then gridarr=[2,180,90]; 2deg
if gidx eq 3 then gridarr=[3,120,60]; 3deg
if gidx eq 4 then gridarr=[4,90,45]; 4deg
if gidx eq 5 then gridarr=[6,60,30]; 6deg

gridstr=strtrim(gidx,1)+'deg'

yy=strmid(datestr,0,4)
mm=strmid(datestr,4,2)
dd=strmid(datestr,6,2)

ddir='/peate_sci/nadias/ak/'+yy+'/'+mm+'/'+dd+'/'

filespec1=ddir+xtype+'caps_'+datestr+'*'+orbit+'*'+sattype1+'*'+param+'_ave_kern_'+gridstr+'.nc'
filespec2=ddir+xtype+'caps_'+datestr+'*'+orbit+'*'+sattype2+'*'+param+'_ave_kern_'+gridstr+'.nc'
;print,filespec1,filespec2
infn1=findfile(filespec1)
infn2=findfile(filespec2)
print,infn1

figtit=datestr+' '+orbit+' '+strupcase(xtype)+'CAPS '+strupcase(sattype1)+' '+xtit+' difference'

out=read_ncdf(infn1,dat1)
out=read_ncdf(infn2,dat2)
;   EFFECTIVE_PRESSURE FLOAT     Array[9]
;   LATITUDE        FLOAT     Array[1800]
;   LONGITUDE       FLOAT     Array[1800]
;   DOF_MU          FLOAT     Array[1800]
;   DOF_SIGMA       FLOAT     Array[1800]
;   AK_MU           FLOAT     Array[9, 1800]
;   AK_SIGMA        FLOAT     Array[9, 1800]
plat=dat1.latitude
plon=dat1.longitude
mdof1=dat1.dof_mu; mean DOF
mdof2=dat2.dof_mu; mean DOF
sdof1=dat1.dof_sigma; standard deviation DOF
sdof2=dat2.dof_sigma; standard deviation DOF

ngrid=n_elements(plon)
nlon=gridarr(1)
nlat=gridarr(2)

;******* Make Figures *********

;====================
; Degrees of freedom
;====================
; Mean
mdiff=mdof1-mdof2
if iparam eq 0 then xrange=[-1.2,1.2]; temperature
if iparam eq 1 then xrange=[-0.3,0.3]; h2o
xmax=xrange(1);max(mdiff)
xmin=xrange(0);min(mdiff)
loadct,72
m = map('Miller',$
 dimensions=[1200, 1000], $
 /nodata,$
 buffer=1,limit=[-90,-180,90,180], $
 margin=[0.1,0.05,0.1,0.05],$
 title=figtit,font_size=22,color='gray')
 mygrid = m.mapgrid
 mygrid.linestyle='dotted'
 mygrid.font_size=14
 mygrid.grid_longitude=40
 mygrid.grid_latitude=20
 mygrid.label_position=-0.05
 mygrid.font_style=1
 mygrid.box_axes=1
 mygrid.box_thick=1

	;rgb=colortable([[1,231,247],[48,158,232],[0,50,188],$
	;[131,113,202],[255,54,54],[218,143,93],[236,246,103]],ncolors=256)
rgb=colortable(['dark blue','snow','deep pink'],ncolors=256)

myimage=image(mdiff,plon,plat,/buffer,/current,overplot=m,$
        grid_units='degrees',$
        rgb_table=rgb,$
        max_value=xmax,min_value=xmin)

cb=colorbar(rgb_table=rgb,textpos=0, taper=1, $
        border=1, orientation=0, range=[xmin,xmax], $
        font_size=18,title=xtit+' Degrees of Freedom for Signal',position=[0.2,0.12,0.8,0.14] )

	jname=xtype+'caps_'+sattype1+'_diff_'+orbit+'_'+datestr+'_'+param+'_DOF.jpg'
	m.save, jname, resolution=120
	print,'figure saved as '+jname

end
