; script biy Nadia to read RAQMS
pro nsplot_stgrid_global_diff

fnclim='/iliad/proxy/nadias/climcaps/fg180321_spacegrid_618hPa.nc'
fnnu='/iliad/proxy/nadias/nucaps/fg180321_spacegrid_618hPa.nc'
!except=0
param='t_mu'
ipos=strpos(fnclim,'hPa')
pval=strtrim(strmid(fnclim,ipos-3,3),2)

;fn='/iliad/proxy/nadias/nucaps/npp/2018/01/netcdf/NUCAPS_20180106_am.nc'
; with this routine 
yy='2018'
deg='1deg';'6deg';'1p5deg'
nlat='120';30;120
nlon='240';60;240

;param='Tdof_sigma'
;see about using TVSCL about plotting an image
;https://www.harrisgeospatial.com/docs/tvscl_procedure.html

pressure=[100.,175.,200.,225.,300.,500.,700.,850.,975.]
claser,psfile="unc.eps",/eps
loadct,39,rgb_table=rgb
mcolor=byte(!p.color)
if mcolor eq 0 then mcolor=255
icmm1=mcolor-1
icmm2=mcolor-2
!p.background=255.
!p.color=0
!p.thick=2.0
!p.charsize=1.5
;latlonlim=[25,-125,55,-70]; [minlat,minlon,maxlat,maxlon]
latlonlim=[-90,-180,90,180]

instr='npp'
datestr='20180321'
orbit='pm'

;------------------------------------------
;------------------------------------------
result=read_ncdf(fnclim,datc)
result=read_ncdf(fnnu,datn)
;------------------------------------------
;------------------------------------------
        ; Define circle as symbol to plot

strc='xc=datc.'+param
strn='xn=datn.'+param
i=execute(strc)
i=execute(strn)
if i eq 0 then exit 
idx=where(xc eq -9999.)
xc(idx)=!Values.F_NAN
idx=where(xn eq -9999.)
xn(idx)=!Values.F_NAN

x0=xc-xn
x0=reform(x0)
	maptitle='CLIMCAPS-NUCAPS '+param+' at '+pval+' hPa on '+datestr+' '+orbit
	jname='xcapsdiff_'+instr+'_'+param+'_'+pval+'.jpg'
;	maptitle=strupcase(xcaps)+'CAPS-'+instr+' '+param+' on '+datestr+' '+orbit
print,maptitle
print,jname

;x0=x0-273.; convert K to C
;idx2=where(x0 le -65.); CAA feature
;idx1=where(x0 gt -65. and x0 le -60.)
;idx0=where(x0 gt -60.)
;x0(idx2)=-65.
;x0(idx1)=1
;x0(idx0)=!Values.F_NAN
s=size(datn.latitude)
x=reform(x0,nlon,nlat)
lats=reform(datn.latitude,nlon,nlat)
lons=reform(datn.longitude,nlon,nlat)
latmin=-90
latmax=90
lonmin=-180
lonmax=180
;loadct,41,rgb_table=ctable
ctable=colortable([[218,143,93],[235,243,240],$
	[0,50,188]],ncolors=256)
;        m = map('Orthographic',center_latitude=60,$

	 m = map('Miller',$
	dimensions=[1200, 1000],$
          /nodata,$
          buffer=1,limit=[-90,-180,90,180], $
;          buffer=1,limit=[38,170,80,245], $
          title=maptitle,font_size=22,color='gray',$
          position=[0.1,0.1,0.95,0.95])
         mygrid = m.mapgrid
         mygrid.linestyle='dotted'
         mygrid.font_size=14
         mygrid.grid_longitude=40
         mygrid.grid_latitude=20
         mygrid.label_position=-0.05
         mygrid.font_style=1
	 mygrid.box_axes=1
	mygrid.box_thick=1
;ct=colortable(20)
;c=contour(x,lons,lats,/fill,overplot=m,$
;/current,grid_units='degrees',$;rgb_table=ct,$
;max_value=30,min_value=-70,$
;c_value=[-100,-70,-65,-64,-62,-60,-55,30],$
;c_color=['indigo','dark blue','medium blue','royal blue','deep sky blue','thistle','Khaki'])
;idx=where(x le -50)
;xmax=1.0;max(x,/nan);-0.2*max(x,/nan)
;xmin=0.0;min(x,/nan);+0.2*min(x,/nan)
;ncol=10
xmax=5.0;max(x,/nan)
xmin=-5.0;min(x,/nan)

;xmax=3.0
;xmin=0.0
;rgb=rgb[50i+25*indgen(10),*]
;rgb=colortable(66)
myimage=image(x,lons,lats,/buffer,/current,overplot=m,$
	grid_units='degrees',$

	rgb_table=ctable,$
 	max_value=xmax,min_value=xmin)	

g_continents = mapcontinents(color = 'black')
; position=[x1,y1,x2,y2]

cb=colorbar(rgb_table=ctable,textpos=0, taper=1, $
	border=1, orientation=0, range=[xmin,xmax], $
	position=[0.25,0.16,0.8,0.185], font_size=16,title='[K]' )

m.save, jname, resolution=120
print,'figure saved as '+jname
end
