pro nsplot_stgrid_global_dof,xtype,param,orbit,sattype,datestr

jname='test.jpg'
!except=0

gidx=1
if gidx eq 1 then gridarr=[1,240,120];[gsize,nlon, nlat] 1.5deg
if gidx eq 2 then gridarr=[2,180,90]; 2deg
if gidx eq 3 then gridarr=[3,120,60]; 3deg
if gidx eq 4 then gridarr=[4,90,45]; 4deg
if gidx eq 5 then gridarr=[6,60,30]; 6deg

;gridstr=strtrim(gridarr(0),1)+'deg'
gridstr=strtrim(gridarr(0),1)
yy=strmid(datestr,0,4)
mm=strmid(datestr,4,2)
dd=strmid(datestr,6,2)

ddir='/peate_sci/nadias/ak/'+yy+'/'+mm+'/'+dd+'/'

filespec=ddir+xtype+'caps_'+datestr+'_'+orbit+'_'+sattype+'_gridded_'+param+'_ave_kern_'+gridstr+'deg.nc'
print,filespec
infn=findfile(filespec)
print,infn

figtit=datestr+' '+strupcase(xtype)+'CAPS '+sattype+' '+orbit+' '+param+' DOFS'

out=read_ncdf(infn,dat)
;   EFFECTIVE_PRESSURE FLOAT     Array[9]
;   LATITUDE        FLOAT     Array[1800]
;   LONGITUDE       FLOAT     Array[1800]
;   DOF_MU          FLOAT     Array[1800]
;   DOF_SIGMA       FLOAT     Array[1800]
;   AK_MU           FLOAT     Array[9, 1800]
;   AK_SIGMA        FLOAT     Array[9, 1800]
plev=dat.effective_pressure
plat=dat.latitude
plon=dat.longitude
mdof=dat.dof_mu; mean DOF
sdof=dat.dof_sigma; standard deviation DOF

nlev=n_elements(plev)
ngrid=n_elements(nlon)
nlon=gridarr(1)
nlat=gridarr(2)

;plat=reform(plat,nlon,nlat)
;plon=reform(plon,nlon,nlat)
;mdof=reform(mdof,nlon,nlat)
;sdof=reform(sdof,nlon,nlat)

;******* Make Figures *********


;====================
; Degrees of freedom
;====================
; Mean
; ozone max=2.0, min=1.2
; co max=1.0, min=0.2
; h2o max=2.5, min=0.5
; t max=3.4, min=2.0
xmin=0.5;max(mdof)
xmax=2.5;min(mdof)
loadct,10
m = map('Miller',$
 dimensions=[1200, 1000], $
 /nodata,$
 buffer=1,limit=[-90,-180,90,180], $
 margin=[0.1,0.05,0.1,0.05],$
 title=figtit,font_size=22,color='gray')
 mygrid = m.mapgrid
 mygrid.linestyle='dotted'
 mygrid.font_size=14
 mygrid.grid_longitude=40
 mygrid.grid_latitude=20
 mygrid.label_position=-0.05
 mygrid.font_style=1
 mygrid.box_axes=1
 mygrid.box_thick=1

	rgb=colortable([[1,231,247],[48,158,232],[0,50,188],$
	[131,113,202],[245,240,175],[236,246,103]],ncolors=256)
rgb=colortable([[243,230,241],[245,211,250],[131,113,202],$
	[0,50,188],[48,158,232],[1,231,247]],ncolors=256)
myimage=image(mdof,plon,plat,/buffer,/current,overplot=m,$
        grid_units='degrees',$
        rgb_table=rgb,$
        max_value=xmax,min_value=xmin)
;g_continents = mapcontinents(color = 'black')

cb=colorbar(rgb_table=rgb,textpos=0, taper=1, $
        border=1, orientation=0, range=[xmin,xmax], $
        font_size=16,title=strupcase(param)+' Degrees of Freedom for Signal',position=[0.2,0.12,0.8,0.14] )

	jname=xtype+'caps_'+sattype+'_'+orbit+'_'+datestr+'_'+param+'_DOF.jpg'
	m.save, jname, resolution=120
	print,'figure saved as '+jname

; StDev


; STDEV Ave Kernel
;
end
