pro nsplot_stgrid_global_ret,param,orbit,datestr,plev

; plev=300,500,800
xtype='nu'
sattype='n20'

jname='test.jpg'
!except=0

gidx=1
if gidx eq 1 then gridarr=[1.5,240,120];[gsize,nlon, nlat] 1.5deg
if gidx eq 2 then gridarr=[2,180,90]; 2deg
if gidx eq 3 then gridarr=[3,120,60]; 3deg
if gidx eq 4 then gridarr=[4,90,45]; 4deg
if gidx eq 5 then gridarr=[6,60,30]; 6deg

gridstr=strtrim(gidx,1)+'deg'

yy=strmid(datestr,0,4)
mm=strmid(datestr,4,2)
dd=strmid(datestr,6,2)

ddir='/ships19/aqda/nadias/'+yy+'/'+mm+'/'+dd+'/retfiles/'

if strcmp(param,'t') then paramstr='Air_Temp'
if strcmp(param,'t') then units='[K]'
if strcmp(param,'q') or strcmp(param,'co') or strcmp(param,'o3') then units='[ppb]'
if strcmp(param,'q') then paramstr='H!I2!NO_Vap'
if strcmp(param,'co') then paramstr='CO'
if strcmp(param,'o3') then paramstr='CO'
filespec=ddir+xtype+'caps_'+datestr+'*'+orbit+'*'+sattype+'*'+strlowcase(param)+'_ret_'+gridstr+'.nc'
infn=findfile(filespec)
print,infn
if plev eq 300 then pidx=0
if plev eq 500 then pidx=1
if plev eq 700 then pidx=2

if plev eq 300 and strcmp(param,'t') then colrange=[210,250]
if plev eq 500 and strcmp(param,'t') then colrange=[225,270]
if plev eq 700 and strcmp(param,'t') then colrange=[235,290]
if plev eq 500 and strcmp(param,'co') then colrange=[100,200]

plevstr=strtrim(plev,1)
figtit=strupcase(xtype)+'CAPS-'+strupcase(sattype)+' '+datestr+orbit+' '+paramstr+' at '+plevstr+'hPa on '+gridstr+' grid'

out=read_ncdf(infn,dat)
;   EFFECTIVE_PRESSURE FLOAT     Array[9]
;   LATITUDE        FLOAT     Array[1800]
;   LONGITUDE       FLOAT     Array[1800]
;   obs_MU          FLOAT     Array[1800]
;   obs_SIGMA       FLOAT     Array[1800]
plat=dat.latitude
plon=dat.longitude
mobs=reform(dat.obs_mu(pidx,*)); mean DOF
if strcmp(param,'q') then begin 
	mobs=mobs/1e20
	colrange=[0,20]
endif
nlev=n_elements(plev)
ngrid=n_elements(nlon)
nlon=gridarr(1)
nlat=gridarr(2)

;******* Make Figures *********

; Mean
xmax=max(mobs,/nan)
xmin=min(mobs,/nan)
print,'++++++++++',xmax,xmin
loadct,10
m = map('Miller',$
 dimensions=[1200, 1000], $
 /nodata,$
 buffer=1,limit=[-90,-180,90,180], $
 margin=[0.1,0.05,0.1,0.05],$
 title=figtit,font_size=22,color='gray')
 mygrid = m.mapgrid
 mygrid.linestyle='dotted'
 mygrid.font_size=14
 mygrid.grid_longitude=40
 mygrid.grid_latitude=20
 mygrid.label_position=-0.05
 mygrid.font_style=1
 mygrid.box_axes=1
 mygrid.box_thick=1
	rgb=colortable([[208,208,238],[0,50,188],$
	[131,113,202],[255,54,54],[218,143,93],[236,246,103]],ncolors=256)

myimage=image(mobs,plon,plat,/buffer,/current,overplot=m,$
        grid_units='degrees',$
        rgb_table=rgb,$
        max_value=colrange(1),min_value=colrange(0))
;g_continents = mapcontinents(color = 'black')

cb=colorbar(rgb_table=rgb,textpos=0, taper=1, $
        border=1,range=colrange, $
        font_size=14,title=paramstr+' '+units,position=[0.2,0.12,0.8,0.14] )

	jname=xtype+'caps_'+sattype+'_'+orbit+'_'+datestr+'_'+param+'_ret_'+plevstr+'hPa.jpg'
	m.save, jname, resolution=120
	print,'figure saved as '+jname
;
end
