; Program to interpolate UW-Hybrid (RAQMS_global) netcdf files
; to flight track. 
;

curtain_dir='/ships19/aqda/bpierce/FIREX-AQ/Flight_data/UW-Hybrid/NUCAPS/'
netcdf_dir='/raqms-arc3/data/CalNex/UW-Hybrid/Mission_1X1/Netcdf/'
filesuff='.chem.assim.nc'

idir=netcdf_dir

cname=['iq','ico','o3vmr','ich4','in2o','ihno3t','iso2']
nchem=n_elements(cname)
bnname=''

;
; nucaps edr files
;
nucaps_files=[$
'NUCAPS.07.22.2019.fil'$
]
nucaps_dates=[$
'07/22'$
]
nucaps_ctimes=[$
'2019072212'$
]
;
; build nucaps date/time
;
ndays=n_elements(nucaps_files)
icount=0l
for nd=0,ndays-1 do begin
print,nucaps_files(nd)
openr,1,nucaps_files(nd)
nfiles=0l
readf,1,nfiles
for nf=0,nfiles- 1 do begin
blank=''
readf,1,blank
;NUCAPS-EDR_v1rx_am_npp_s20160306000832_e20160306000902_scicode.nc
;NUCAPS-sciEDR_am_npp_s20190730071807_e20190730071837_STC.nc
;NUCAPS-EDR_pm_npp_s20190809055335_e20190809055405_sciEDR_fsr.nc
; rbp 4/7/20 these are NOT npp, they are NOAA20
;NUCAPS-sciEDR_am_npp_s20190722003607_e20190722004405_STC_fsr.nc
; rbp 4/7/20 these are NOAA20 but have an additional "0" in both s and e time stamps. 
;nucaps_n20_am_s201907220036070_e201907220044050_AK.nc
;
; new files from Nadia on  May 22-26, 2020
;
;NUCAPS-sciEDR_n20_am_s201907221116070_e201907221124050.nc
;
;NUCAPS_sciAK_n20_am_s201907221116070_e201907221124050.nc
if icount eq 0l then begin
result=str_sep(blank,'_')
orbit=result(2)
if orbit eq 'am' then goto, jumpout
date=result(3)
year=long(strmid(date,1,4))
month=long(strmid(date,5,2))
day=long(strmid(date,7,2))
hour=long(strmid(date,9,2))
minute=long(strmid(date,11,2))
second=long(strmid(date,13,2))
utcsec0=60.*60.*hour+60.*minute+second
;
date1=result(4)
year1=long(strmid(date1,1,4))
month1=long(strmid(date1,5,2))
day1=long(strmid(date1,7,2))
hour1=long(strmid(date1,9,2))
minute1=long(strmid(date1,11,2))
second1=long(strmid(date1,13,2))
utcsec1=60.*60.*hour1+60.*minute1+second1

print,year,month,day,hour,minute,second
;if hour ge 15l then goto, jumpout
nucaps_file_ret=blank
if orbit eq 'am' then blank_ak='NUCAPS_sciAK_n20_am_'+date+'0'+'_'+date1+'.nc'
if orbit eq 'pm' then blank_ak='NUCAPS_sciAK_n20_pm_'+date+'0'+'_'+date1+'.nc'
nucaps_file_ak=blank_ak
nucaps_year=strmid(date,1,4)
nucaps_month=strmid(date,5,2)
nucaps_day=strmid(date,7,2)
nucaps_date=nucaps_dates(nd)
jday0=julday(1l,0l,year,0l,0l,0l)
jday_nucaps=julday(month,day,year,hour,minute,second)-jday0
endif
if icount gt 0l then begin
result=str_sep(blank,'_')
orbit=result(1)
if orbit eq 'am' then goto, jumpout
date=result(3)
year=long(strmid(date,1,4))
month=long(strmid(date,5,2))
day=long(strmid(date,7,2))
hour=long(strmid(date,9,2))
minute=long(strmid(date,11,2))
second=long(strmid(date,13,2))
utcsec0=60.*60.*hour+60.*minute+second
;
date1=result(4)
year1=long(strmid(date1,1,4))
month1=long(strmid(date1,5,2))
day1=long(strmid(date1,7,2))
hour1=long(strmid(date1,9,2))
minute1=long(strmid(date1,11,2))
second1=long(strmid(date1,13,2))
utcsec1=60.*60.*hour1+60.*minute1+second1
;if hour ge 15l then goto, jumpout
nucaps_file_ret=[nucaps_file_ret,blank]
nucaps_file_ak=[nucaps_file_ak,blank_ak]
nucaps_year=[nucaps_year,strmid(date,1,4)]
nucaps_month=[nucaps_month,strmid(date,5,2)]
nucaps_day=[nucaps_day,strmid(date,7,2)]
nucaps_date=[nucaps_date,nucaps_dates(nd)]
jday_nucaps=[jday_nucaps,julday(month,day,year,hour,minute,second)-jday0]
print,year,month,day,hour,minute,second
endif
icount=icount+1l
jumpout:
endfor
close,1
endfor
help,nucaps_file_ret,nucaps_file_ak
help,jday_nucaps
nucaps_dir='/ships19/aqda/nadias/'


ndays=n_elements(nucaps_dates)
for nd=0,ndays-1 do begin
ctime=nucaps_ctimes(nd)
year=long(strmid(ctime,0,4))
month=long(strmid(ctime,4,2))
day=long(strmid(ctime,6,2))
hour=long(strmid(ctime,8,2))
jday_traj=julday(month,day,year,hour,0l,0l)-jday0
cindex=where(24.*abs(jday_nucaps-jday_traj) le 12.)
;
; open coincident nucaps edr files
;
ncoin=n_elements(cindex)
for nf=0,ncoin-1 do begin
print,nucaps_dir+nucaps_year(cindex(nf))+'/'+nucaps_date(cindex(nf))+'/retfiles/'+nucaps_file_ret(cindex(nf))
result=str_sep(nucaps_file_ret(cindex(nf)),'_')
orbit=result(1)
date=result(3)
year=long(strmid(date,1,4))
month=long(strmid(date,5,2))
day=long(strmid(date,7,2))
hour=long(strmid(date,9,2))
minute=long(strmid(date,11,2))
second=long(strmid(date,13,2))
utcsec0=60.*60.*hour+60.*minute+second
;
date1=result(4)
year1=long(strmid(date1,1,4))
month1=long(strmid(date1,5,2))
day1=long(strmid(date1,7,2))
hour1=long(strmid(date1,9,2))
minute1=long(strmid(date1,11,2))
second1=long(strmid(date1,13,2))
utcsec1=60.*60.*hour1+60.*minute1+second1
bnname=nucaps_file_ret(cindex(nf))
    nc_file_id=ncdf_open(nucaps_dir+nucaps_year(cindex(nf))+'/'+nucaps_date(cindex(nf))+'/retfiles/'+nucaps_file_ret(cindex(nf)),/nowrite)
    glob_info=ncdf_inquire(nc_file_id)
;    print,'number of dimensions ',glob_info.ndims
;    print,'number of variables ',glob_info.nvars
;    print,'number of attributes ',glob_info.ngatts

; get dimensions
;
    for idim=0,glob_info.ndims-1 do begin
    ncdf_diminq,nc_file_id, idim, name, dim
;    print,'dimension ',idim,name,dim
    if name eq 'Number_of_CrIS_FORs' then nfor=dim
    if name eq 'Number_of_P_Levels' then nlev=dim
    endfor
    for ivar=0,glob_info.nvars-1 do begin
    result=ncdf_varinq(nc_file_id,ivar)
;    print,'variable ',ivar,result.name,result.datatype,result.ndims
    endfor
    ncdf_varget,nc_file_id,'Time',nucaps_time
    ncdf_varget,nc_file_id,'Latitude',lats
    ncdf_varget,nc_file_id,'Longitude',lons
;
; close netCDF file
;
    ncdf_close,nc_file_id
utcsec=utcsec0+(utcsec1-utcsec0)*findgen(nfor)/(1.*nfor-1.)
print,max(utcsec),min(utcsec)
;bindex=where(nucaps_time le 0.0)
;if bindex(0) ne -1 then begin
;gindex=where(nucaps_time gt 0.0)
;nucaps_time(bindex)=interpol(nucaps_time(gindex),gindex,bindex)
;endif
;utcsec=nucaps_time-nucaps_time(0)+hour*60.*60.+minute*60.+second
lat_centre=lats
lon_centre=lons
nv=nfor
icount=nv
;
; account for utcsec crossing day
;
for n=1,icount-1 do begin
if utcsec(n-1)-utcsec(n) gt 12.*60.*60. then begin
utcsec(n:icount-1)=utcsec(n:icount-1)+24.*60.*60.
print,'Adjusted utcsec to account for crossing day!!!!!!!!!!!!!!!!!!!!!!!!!!!111'
goto,jumputcfix
endif
endfor
jumputcfix:
print,max(lon_centre),min(lat_centre)
close,2
nvalues=n_elements(lat_centre)
imon=min(month)
iday=min(day)
iyear=min(year)
print,imon,iday,iyear
date=strtrim(imon)+strtrim(iday)+strtrim(iyear)
print,date
print,utcsec(0),utcsec(nvalues-1)
  flight_start=julday(imon,iday,iyear,0.,0.,utcsec(0))
  flight_stop=julday(imon,iday,iyear,0.,0.,utcsec(nvalues-1))
  daynum=julday(imon,iday,iyear)-julday(1,0,iyear)
  xjday=float(daynum)+fltarr(nvalues)
  jdaystart=daynum
  daynum2=flight_stop-julday(1,0,iyear)
  jdaystop=round(daynum2)

  caldat,flight_start,mn1,dy1,yr1,hr1,min1,sec1
  time1=float(hr1)+float(min1)/60.+sec1/3600.
  caldat,flight_stop,mn2,dy2,yr2,hr2,min2,sec2
  time2=float(hr2)+float(min2)/60.+sec2/3600.
;
; brad patch to max time =24Z
;
;  if time2 le 1. then time2=24.
  print,'start time: ',jdaystart,mn1,dy1,time1
  print,'stop  time: ',jdaystop,mn2,dy2,time2
;Determine how many model files are needed
  hours=[0.,6.,12.,18.,24.]
  test1=where(hours le time1,c1)
  test2=where(hours ge time2,c2)
  nday=jdaystop-jdaystart+1
  nmodper=1+round(nday)*4-(c1-1)-(c2-1)
  modfiles=strarr(nmodper)
  ox24files=strarr(nmodper)
  thishour=long(round(hours(test1(c1-1))))
  print,nmodper,' model files needed:'
  uwhyb_time=dblarr(nmodper)
;Build list of model filenames
  for i=0,nmodper-1 do begin
    modtime=julday(1,xjday(0),2019,thishour,0,0)
    uwhyb_time(i)=modtime
    caldat,modtime,mn0,dy0,yr0,hr0,min0,sec0
    hh=round(float(hr0)+float(min0)/60.+sec0/3600.)
    syr=strtrim(yr0,2)
    smn=strtrim(mn0,2)
    if strlen(smn) eq 1 then smn='0'+smn
    sdy=strtrim(dy0,2)
    if strlen(sdy) eq 1 then sdy='0'+sdy
    shr=strtrim(hh,2)
    if strlen(shr) eq 1 then shr='0'+shr
; turn on if monthsubdirectories
;goto, nomonthsubdirectories
;Determine path (date subdirectory) to model files
    if hh ge 12 then begin
      dir=strmid(syr,2,2)+smn+sdy+'/'
;      dir=strmid(syr,2,2)+smn+sdy+'_12Z_2X2/'
;if directory doesn't exist, we are in fx period and need to use latest directory
      test=findfile(idir+dir)
      if test(0) eq '' then begin
        test=findfile(idir)
        dirs=where(strpos(test,'19') ge 0)
        test=test(dirs)
        latest=test(n_elements(test)-1)
        dir=latest+'/'
;      dir=latest+'_12Z_2X2/'
      endif
    endif else begin
      dirtime=julday(1,xjday(0),2019,thishour-24,0,0)
      caldat,dirtime,mn3,dy3,yr3,hr3,min3,sec3
      hh3=round(float(hr3)+float(min3)/60.+sec3/3600.)
      syr3=strtrim(yr3,2)
      smn3=strtrim(mn3,2)
      if strlen(smn3) eq 1 then smn3='0'+smn3
      sdy3=strtrim(dy3,2)
      if strlen(sdy3) eq 1 then sdy3='0'+sdy3
      shr3=strtrim(hh3,2)
      if strlen(shr3) eq 1 then shr3='0'+shr3
      dir=strmid(syr3,2,2)+smn3+sdy3+'/'
;      dir=strmid(syr,2,2)+smn3+sdy3+'_12Z_2X2/'
      ;if directory doesn't exist, we are in fx period and need to use latest directory
      test=findfile(idir+dir)
      if test(0) eq '' then begin
        test=findfile(idir)
        dirs=where(strpos(test,'19') ge 0)
        test=test(dirs)
        latest=test(n_elements(test)-1)
        dir=latest+'/'
;      dir=latest+'_12Z_2X2/'
      endif
    endelse
;    if hh ge 12 then begin
;      dir=strmid(syr,2,2)+smn+sdy+'/'
;      ;if directory doesn't exist, we are in fx period and need to use latest directory
;      test=findfile(idir+dir)
;    endif else begin
;      dirtime=julday(1,xjday(0),2014,thishour-24,0,0)
;      caldat,dirtime,mn3,dy3,yr3,hr3,min3,sec3
;      hh3=round(float(hr3)+float(min3)/60.+sec3/3600.)
;      syr3=strtrim(yr3,2)
;      smn3=strtrim(mn3,2)
;      if strlen(smn3) eq 1 then smn3='0'+smn3
;      sdy3=strtrim(dy3,2)
;      if strlen(sdy3) eq 1 then sdy3='0'+sdy3
;      shr3=strtrim(hh3,2)
;      if strlen(shr3) eq 1 then shr3='0'+shr3
;      dir=strmid(syr3,2,2)+smn3+sdy3+'/'
;      ;if directory doesn't exist, we are in fx period and need to use latest directory
;      test=findfile(idir+dir)
;    endelse
; if date subdirectories exist
    modfiles(i)=idir+dir+'uwhyb_'+smn+'_'+sdy+'_'+syr+'_'+shr+'Z'+filesuff
nomonthsubdirectories:
; if date subdirectories don't exist
;   modfiles(i)=idir+'uwhyb_'+smn+'_'+sdy+'_'+syr+'_'+shr+'Z'+filesuff
    print,modfiles(i)
    thishour=thishour+6L
  endfor
  itotal=nvalues
  isave=intarr(itotal) & jsave=isave & lsave=isave
  xfsave=fltarr(itotal) & yfsave=xfsave & pfsave=xfsave
  xsave=fltarr(itotal) & ysave=fltarr(itotal)
  cocount=itotal
  yco=lat_centre
  xco=lon_centre
  psfc_mod=0.*lon_centre
  ptrop_mod=0.*lon_centre
  sco=dblarr(itotal)
  for i=0l,nvalues-1l do begin
;    actime=julday(1,xjday(i),2004,xhour(i),xmin(i),xsec(i))
    actime=julday(imon,iday,iyear,0.,0.,utcsec(i))
    sco(i)=actime
  endfor
xco=lon_centre
yco=lat_centre
  index=where(xco le 0.)
  if index(0) ne -1 then xco(index)=360.+xco(index)
;
; interpolate to measurement position
;
  print,' interpolating to measurement position '
  print,' cocount =',cocount 
;
;INTEX grid (NCEP)
  nc=144L
  nr=91L
  nl=35L
  alon=2.5*findgen(nc)
  alat=-90+2*findgen(nr)
  alon0=alon
  alat0=alat
; INTEX 1.4 grid (NCEP)
  nc=256L
  nr=128L
  nl=35L
  alon=1.40698*findgen(nc)
  alat=-90.+1.41730*findgen(nr)
; INTEX-B 2x2 Grid
  nc=180L
  nr=91L
  alon=2.*findgen(nc)
  alat=-90+2.*findgen(nr)
; CalNex 1x1 grid
  nc=360L
  nr=181L
  alon=1.*findgen(nc)
  alat=-90+1.*findgen(nr)

  alon0=alon
  alat0=alat
;
; Need to consider wrap longitude
  salon=shift(alon,-1)
  salon(nc-1)=360.
  salat=shift(alat,-1)
;
; UWNMS grid is uniform lat/lon, so simple space interp.
;
  for n=0L,cocount-1l do begin
;    if n mod 50 eq 0 then print,100.*n/cocount,' Percent done' 
    xp = xco(n)
    yp = yco(n) 

    iloc=where(alon le xp and salon gt xp,cx)
    jloc=where(alat le yp and salat gt yp,cy)
    if cx ne 1 or cy ne 1 then begin
    ;print,'Unable to interpolate'
    isave(n)=-999
    jsave(n)=-999
    xfsave(n)=-999
    yfsave(n)=-999
    endif else begin
    iloc=iloc(0)
    jloc=jloc(0)
    isave(n)=iloc
    jsave(n)=jloc
    xfsave(n)=(xp-alon(iloc))/(salon(iloc)-alon(iloc))
    yfsave(n)=(yp-alat(jloc))/(salat(jloc)-alat(jloc))
    endelse

  endfor  ;n loop

;
;Have position interpolating info, now read uwhyb files and interpolate
; in space and time
;

  curtain=fltarr(nchem,nl,itotal)
  pcurt=fltarr(nl,itotal)
  uucurt=fltarr(nl,itotal)
  vvcurt=fltarr(nl,itotal)
  thcurt=fltarr(nl,itotal)

  for itime=0,nmodper-1 do begin
    nleft=0 & left=[0L]
    nright=0 & right=[0L]
    if itime lt nmodper-1 then $
     right=where(sco ge uwhyb_time(itime) and $
                sco lt uwhyb_time(itime+1),nright)
    if itime gt 0 then $
     left=where(sco ge uwhyb_time(itime-1) and $
                sco lt uwhyb_time(itime),nleft)
;
    netcdf_file=modfiles(itime)
;spawn,'cp '+idir+netcdf_file+'.gz'+' /data/pierce/Scratch/'
;spawn,'gunzip /data/pierce/Scratch/*'
    print,' reading from UWHYB analysis file',netcdf_file
;    nc_file_id=ncdf_open('/data/pierce/Scratch/'+netcdf_file,/nowrite)
    nc_file_id=ncdf_open(netcdf_file,/nowrite)

;
    glob_info=ncdf_inquire(nc_file_id)
;    if itime eq 0 then begin
;    print,'number of dimensions ',glob_info.ndims
;    print,'number of variables ',glob_info.nvars
;    print,'number of attributes ',glob_info.ngatts
;    endif

; get dimensions
;
    for idim=0,glob_info.ndims-1 do begin
    ncdf_diminq,nc_file_id, idim, name, dim
    if itime eq 0 then print,'dimension ',idim,name,dim
    if name eq 'lat' then nlat=dim
    if name eq 'lon' then nlon=dim
    if name eq 'lev' then nlev=dim
    if name eq 'theta' then nth=dim
    endfor
    ;print,nlat,nlon,nlev
    ncdf_varget,nc_file_id,'lat',alat
    ncdf_varget,nc_file_id,'lon',alon
    ncdf_varget,nc_file_id,'lev',alev
    ncdf_varget,nc_file_id,'theta',theta
;
;    if itime eq 0 then begin
;    for ivar=0,glob_info.nvars-1 do begin
;    result=ncdf_varinq(nc_file_id,ivar)
;    print,'variable ',ivar,result.name,result.datatype,result.ndims
;    endfor
;    endif
;;
;; declare arrays
;;
;    p=fltarr(nlon,nlat,nlev)
;    psfc=fltarr(nlon,nlat)
;
; get variables
;
    ncdf_varget,nc_file_id,'pdash',p
    ncdf_varget,nc_file_id,'psfc',psfc
    ncdf_varget,nc_file_id,'ptrop',ptrop
    ncdf_varget,nc_file_id,'uu',uu
    ncdf_varget,nc_file_id,'vv',vv
    ncdf_varget,nc_file_id,'ttheta',ttheta
;
; map chemical variables to 3d array one at a time
;
    d4d=fltarr(nlon,nlat,nlev,nchem)
;    dummy=fltarr(nlon,nlat,nlev)
    for k=0,nchem-1 do begin
      ncdf_varget,nc_file_id,cname(k),dummy
;      if k eq 0 then dummy=dummy*28.964/18.0153  ;mw dry air/mw h2o
      if cname(k) eq 'oxften' then begin
        ncdf_varget,nc_file_id,'oxdten',dummy2
        dummy = dummy-dummy2
        dummy2 = 0.
        ncdf_varget,nc_file_id,'o3dep',dummy2
        dummy(*,*,nlev-1) = dummy(*,*,nlev-1)+dummy2
        dummy2 = 0.
      endif
      d4d(*,*,*,k)=dummy
    endfor
;    z2d=fltarr(nlon,nlat)
    ncdf_varget,nc_file_id,'zsfc',z2d
;
; close netCDF file
;
    ncdf_close,nc_file_id
;spawn,'/bin/rm /data/pierce/Scratch/*.nc'

;
    ; d4d is stored (lons,lats,levs,species) 
    ; z2d is z of the ground - convert to km
    z2d=z2d/1000.

    for ilr=0,1 do begin
     if ilr eq 0 then begin
      count=nleft
      index=left
      print,'# points earlier than current uwhyb output file',count
     endif else begin
      count=nright
      index=right
      print,'# points later than current uwhyb output file',count
     endelse
     if count gt 0 then begin
      for nn=0l,count-1l do begin
        n=index(nn)
        i=isave(n)
        ip1=(i+1) mod nc   ;account for wrap longitude
        j=jsave(n)
        xfac=xfsave(n)
        yfac=yfsave(n)
        if i ne -999 and j ne -999 then begin
          facij=(1.-xfac)*(1.-yfac)
          facijp1=(1.-xfac)*yfac
          facip1j=xfac*(1.-yfac)
          facip1jp1=xfac*yfac
          if ilr eq 0 then $
           tfac=(sco(n)-uwhyb_time(itime-1))/ $
                (uwhyb_time(itime)-uwhyb_time(itime-1)) $
          else $
           tfac=(uwhyb_time(itime+1)-sco(n))/ $
                (uwhyb_time(itime+1)-uwhyb_time(itime))
          ;print,'time factor= ',tfac
          for k=0,nchem-1 do begin
            for l=0,nlev-1 do begin
              colp=facij*  d4d(i,j,l,k)     + facijp1*  d4d(i,j+1,l,k)+ $
                   facip1j*d4d(ip1,j,l,k)   + facip1jp1*d4d(ip1,j+1,l,k)
              curtain(k,l,n)=curtain(k,l,n)+tfac*colp
              if k eq 0 then begin
                colp=facij*  p(i,j,l)     + facijp1*  p(i,j+1,l)+ $
                   facip1j*p(ip1,j,l)   + facip1jp1*p(ip1,j+1,l)
                pcurt(l,n)=pcurt(l,n)+tfac*colp
                colp=facij* uu(i,j,l)     + facijp1* uu(i,j+1,l)+ $
                    facip1j*uu(ip1,j,l)   + facip1jp1*uu(ip1,j+1,l)
                uucurt(l,n)=uucurt(l,n)+tfac*colp
                colp=facij* vv(i,j,l)     + facijp1* vv(i,j+1,l)+ $
                    facip1j*vv(ip1,j,l)   + facip1jp1*vv(ip1,j+1,l)
                vvcurt(l,n)=vvcurt(l,n)+tfac*colp
                colp=facij* ttheta(i,j,l)     + facijp1* ttheta(i,j+1,l)+ $
                    facip1j*ttheta(ip1,j,l)   + facip1jp1*ttheta(ip1,j+1,l)
                thcurt(l,n)=thcurt(l,n)+tfac*colp
              endif
            endfor
          endfor
;
; get model surface pressure
;
              colp=facij* psfc(i,j)     + facijp1* psfc(i,j+1)+ $
                    facip1j*psfc(ip1,j)   + facip1jp1*psfc(ip1,j+1)
              psfc_mod(n)=psfc_mod(n)+tfac*colp
;
; get model trop pressure
;
              colp=facij* ptrop(i,j)     + facijp1* ptrop(i,j+1)+ $
                    facip1j*ptrop(ip1,j)   + facip1jp1*ptrop(ip1,j+1)
              ptrop_mod(n)=ptrop_mod(n)+tfac*colp
        endif
      endfor
     endif
    endfor
    ;Save space
    print,' '
    d4d=0.
    uu=0.
    vv=0.
    ttheta=0.
  endfor
  ofile=curtain_dir+bnname+'_curtain_1x1_mission.dat'
  close,20
  openw,20,ofile,/f77
  writeu,20,nchem,nl,itotal
;  writeu,20,sco
  writeu,20,utcsec
  writeu,20,xco
  writeu,20,yco
  writeu,20,psfc_mod
  writeu,20,ptrop_mod
  writeu,20,pcurt
  writeu,20,curtain
  writeu,20,uucurt
  writeu,20,vvcurt
  writeu,20,thcurt

  close,20
;Save space
  curtain=0.
  pcurt=0.
  uucurt=0.
  vvcurt=0.
  thcurt=0.
endfor  ;flight loop
endfor  ; end day loop
end
