@calc_finv
@slb2fin
set_plot,'x'
device,retain=2,decomposed=0,true_color=24
set_plot,'z'
loadct,38
mcolor=byte(!p.color)
if mcolor eq 0 then mcolor=255
icmm1=mcolor-1
icmm2=mcolor-2

setplot='Z'
set_plot,setplot
loadct,39
set_viewport,0,1,0,1
!p.background=255.
!p.color=256.
!p.thick=2.0                   ;Plotted lines twice as thick
!p.charsize=1.5
erase
; Program to interpolate UW-Hybrid (RAQMS_global) netcdf files
; to flight track. 
;
setplot='Z'
; Specify window size
nxpix=1880L
nypix=1440L

if setplot eq 'Z' then begin
;-------------------------------------------
set_plot,'Z'
device,set_resolution=[nxpix,nypix],z_buffer=0
nxpng=!d.x_size
nypng=!d.y_size
  loadct,45,file='./color_ck.tbl'
  !p.background=255B
  !p.color=254B
endif
mcolor=byte(!p.color)
icmm1=mcolor-1
icmm2=mcolor-2
!p.font=1
!p.charsize=1.5
a=findgen(9)*(2*!pi/8.)
usersym,.5*cos(a),.5*sin(a),/fill


curtain_dir='/ships19/aqda/bpierce/FIREX-AQ/Flight_data/UW-Hybrid/NUCAPS/'

datdir='/ships19/aqda/nadias/'
bnname=''

;
; new files from Nadia on  May 22-26, 2020
;
;NUCAPS-sciEDR_n20_am_s201907221116070_e201907221124050.nc
;
;NUCAPS_sciAK_n20_am_s201907221116070_e201907221124050.nc
;
days=[$
'NUCAPS.07.22.2019.fil'$
]
ndays=n_elements(days)
for nd=0,ndays-1 do begin
erase
result=str_sep(days(nd),'.')
label=result(1)+' '+result(2)+' '+result(3)+' '+result(4)
date=result(1)+'.'+result(2)+'.'+result(3)+'.'+result(4)
openr,1,days(nd)
nfiles=0l
readf,1,nfiles
cname=['iq','ico','o3vmr','ich4']
nchem=n_elements(cname)
icount=0
nobs_sav=0l
for nf=0,nfiles-1 do begin
readf,1,bnname
result=str_sep(bnname,'_')
orbit=result(2)
if orbit eq 'am' then goto, jumpout
date=result(3)
year=long(strmid(date,1,4))
month=long(strmid(date,5,2))
day=long(strmid(date,7,2))
hour=long(strmid(date,9,2))
minute=long(strmid(date,11,2))
second=long(strmid(date,13,2))
utcsec0=60.*60.*hour+60.*minute+second
;
date1=result(4)
year1=long(strmid(date1,1,4))
month1=long(strmid(date1,5,2))
day1=long(strmid(date1,7,2))
hour1=long(strmid(date1,9,2))
minute1=long(strmid(date1,11,2))
second1=long(strmid(date1,13,2))
utcsec1=60.*60.*hour1+60.*minute1+second1

print,year,month,day,hour,minute,second
nucaps_file_ret=bnname
if orbit eq 'am' then blank_ak='NUCAPS_sciAK_n20_am_'+date+'_'+date1
if orbit eq 'pm' then blank_ak='NUCAPS_sciAK_n20_pm_'+date+'_'+date1
nucaps_file_ak=blank_ak
nucaps_year=strmid(date,1,4)
nucaps_month=strmid(date,5,2)
nucaps_day=strmid(date,7,2)
jday0=julday(1l,0l,year,0l,0l,0l)
jday_nucaps=julday(month,day,year,hour,minute,second)-jday0
cname=['iq','ico','o3vmr','ico']
nchem=n_elements(cname)
label='NUCAPS'
year=strmid(bnname,22,4)
month=strmid(bnname,26,2)
day=strmid(bnname,28,2)

ilab=strmid(bnname,0,36)
;gmt=float(hour)+float(minute)/60.+float(second)/(60.*60.)
print,datdir+year+'/'+month+'/'+day+'/'+'/retfiles/'+bnname
    nc_file_id=ncdf_open(datdir+year+'/'+month+'/'+day+'/'+'/retfiles/'+bnname,/nowrite)

;
    glob_info=ncdf_inquire(nc_file_id)
;    print,'number of dimensions ',glob_info.ndims
;    print,'number of variables ',glob_info.nvars
;    print,'number of attributes ',glob_info.ngatts

; get dimensions
;
    for idim=0,glob_info.ndims-1 do begin
    ncdf_diminq,nc_file_id, idim, name, dim
    print,'dimension ',idim,name,dim
    if name eq 'Number_of_CrIS_FORs' then nfor=dim
    if name eq 'Number_of_P_Levels' then nl=dim
    endfor
;dimension        0Number_of_CrIS_FORs        1800
;dimension        1Number_of_P_Levels         100
;dimension        2Number_of_Cloud_Layers           8
;dimension        3Number_of_L2spares         512
;
    for ivar=0,glob_info.nvars-1 do begin
    result=ncdf_varinq(nc_file_id,ivar)
;    print,'; variable ',ivar,result.name,result.datatype,result.ndims
    endfor
; variable        0CrIS_FORLONG           1
; variable        1nlevLONG           1
; variable        2TimeDOUBLE           1
; variable        3LatitudeFLOAT           1
; variable        4LongitudeFLOAT           1
; variable        5View_AngleFLOAT           1
; variable        6Surface_PressureFLOAT           1
; variable        7Surface_TemperatureFLOAT           1
; variable        8Skin_TemperatureFLOAT           1
; variable        9Quality_FlagLONG           1
; variable       10TopographyFLOAT           1
; variable       11Land_FractionFLOAT           1
; variable       12TPWFLOAT           1
; variable       13O3DUFLOAT           1
; variable       14Mean_CO2FLOAT           1
; variable       15Trop_TFLOAT           1
; variable       16Trop_PFLOAT           1
; variable       17Trop_ZFLOAT           1
; variable       18Effective_PressureFLOAT           2
; variable       19PressureFLOAT           2
; variable       20O3_MRFLOAT           2
; variable       21O3FLOAT           2
; variable       22CO2FLOAT           2
; variable       23CO_MRFLOAT           2
; variable       24COFLOAT           2
; variable       25CH4_MRFLOAT           2
; variable       26CH4FLOAT           2
; variable       27H2O_MRFLOAT           2
; variable       28H2OFLOAT           2
; variable       29RelHumFLOAT           2
; variable       30SpecHumFLOAT           2
; variable       31Layer_TemperatureFLOAT           2
; variable       32TemperatureFLOAT           2
; variable       33N2O_MRFLOAT           2
; variable       34N2OFLOAT           2
; variable       35HNO3_MRFLOAT           2
; variable       36HNO3FLOAT           2
; variable       37SO2_MRFLOAT           2
; variable       38SO2FLOAT           2
; variable       39pmultFLOAT           2
; variable       40Cloud_Top_FractionFLOAT           2
; variable       41Cloud_Top_PressureFLOAT           2
; variable       42Ispare_FieldLONG           2
; variable       43Rspare_FieldFLOAT           2
    ;print,nlat,nlon,nlev
    ncdf_varget,nc_file_id,'Latitude',alat
    ncdf_varget,nc_file_id,'Longitude',alon
    ncdf_varget,nc_file_id,'Time',time
;
    ncdf_varget,nc_file_id,'Surface_Pressure',psfc2d
    ncdf_varget,nc_file_id,'Land_Fraction',pland
;    ncdf_varget,nc_file_id,'dof',dof
;    ncdf_varget,nc_file_id,'viewang',viewang
;    ncdf_varget,nc_file_id,'solzang',solzang
    ncdf_varget,nc_file_id,'Quality_Flag',qual
;
;    ncdf_varget,nc_file_id,'Effective_Pressure',peff
;    ncdf_varget,nc_file_id,'x_r',x_r
;    ncdf_varget,nc_file_id,'x_rd',x_rd
;    ncdf_varget,nc_file_id,'x_a',x_a
;    ncdf_varget,nc_file_id,'x_ad',x_ad
;    ncdf_varget,nc_file_id,'finex',finex
;    ncdf_varget,nc_file_id,'ak',ak
;    ncdf_varget,nc_file_id,'finv',finv
;    ncdf_varget,nc_file_id,'numlev',numlev
    ncdf_varget,nc_file_id,'nlev',nlev
;
; rbp added for nadia integration
;
     ncdf_varget,nc_file_id,'CO_MR',co_ret
     ncdf_varget,nc_file_id,'CO',co_ret_pcol
     ncdf_varget,nc_file_id,'pmult',pmult
     ncdf_varget,nc_file_id,'Effective_Pressure',effective_pressure
; x_r is already adjusted for surface pressure. NO NEED TO MULTIPLY WITH PMULT
s=size(co_ret)
ret_nlev=s(1)
nobs=s(2)
; need pmult to multiply with x_a to adjust for surface pressure

; (2) Read NUCAPS AK and CO a-priori
;
; close netCDF file
;
    ncdf_close,nc_file_id
print,datdir+year+'/'+month+'/'+day+'/'+'/akfiles/'+bnname
    nc_file_id=ncdf_open(datdir+year+'/'+month+'/'+day+'/'+'akfiles/'+nucaps_file_ak,/nowrite)

;
    glob_info=ncdf_inquire(nc_file_id)
;    print,'number of dimensions ',glob_info.ndims
;    print,'number of variables ',glob_info.nvars
;    print,'number of attributes ',glob_info.ngatts

; get dimensions
;
    for idim=0,glob_info.ndims-1 do begin
    ncdf_diminq,nc_file_id, idim, name, dim
;    print,'dimension ',idim,name,dim
    if name eq 'Number_of_CrIS_FORs' then nfor=dim
    if name eq 'Number_of_P_Levels' then nl=dim
    endfor
;dimension        0atrack*xtrack        1800
;dimension        1air_temp_func_idx          24
;dimension        2air_temp_func_pres          23
;dimension        3h2o_vap_func_idx          12
;dimension        4h2o_vap_func_pres          11
;dimension        5co_func_idx          10
;dimension        6co_func_pres           9
;dimension        7co2_func_idx           9
;dimension        8co2_func_pres           8
;dimension        9ch4_func_idx          12
;dimension       10ch4_func_pres          11
;dimension       11hno3_func_idx           9
;dimension       12hno3_func_pres           8
;dimension       13o3_func_idx          10
;dimension       14o3_func_pres           9
;dimension       15bnds_1d           2
;dimension       16pressure_layers         100
;
    for ivar=0,glob_info.nvars-1 do begin
    result=ncdf_varinq(nc_file_id,ivar)
;    print,'; variable ',ivar,result.name,result.datatype,result.ndims
    endfor
; variable        0latitudeFLOAT           1
; variable        1longitudeFLOAT           1
; variable        2qcmaskFLOAT           1
; variable        3air_temp_ave_kernFLOAT           3
; variable        4h2o_vap_ave_kernFLOAT           3
; variable        5co_ave_kernFLOAT           3
; variable        6co2_ave_kernFLOAT           3
; variable        7ch4_ave_kernFLOAT           3
; variable        8hno3_ave_kernFLOAT           3
; variable        9o3_ave_kernFLOAT           3
; variable       10co_fgFLOAT           2
; variable       11air_temp_func_indxsINT           1
; variable       12h2o_vap_func_indxsINT           1
; variable       13co_func_indxsINT           1
; variable       14co2_func_indxsINT           1
; variable       15ch4_func_indxsINT           1
; variable       16hno3_func_indxsINT           1
; variable       17o3_func_indxsINT           1
; variable       18air_temp_func_presFLOAT           1
; variable       19h2o_vap_func_presFLOAT           1
; variable       20co_func_presFLOAT           1
; variable       21co2_func_presFLOAT           1
; variable       22ch4_func_presFLOAT           1
; variable       23hno3_func_presFLOAT           1
; variable       24o3_func_presFLOAT           1
; variable       25air_temp_func_last_indxINT           1
; variable       26h2o_vap_func_last_indxINT           1
; variable       27co_func_last_indxINT           1
; variable       28co2_func_last_indxINT           1
; variable       29ch4_func_last_indxINT           1
; variable       30hno3_func_last_indxINT           1
; variable       31o3_func_last_indxINT           1
; variable       32air_temp_bot_func_pres_effFLOAT           1
; variable       33h2o_vap_bot_func_pres_effFLOAT           1
; variable       34co_bot_func_pres_effFLOAT           1
; variable       35co2_bot_func_pres_effFLOAT           1
; variable       36ch4_bot_func_pres_effFLOAT           1
; variable       37hno3_bot_func_pres_effFLOAT           1
; variable       38o3_bot_func_pres_effFLOAT           1
     ncdf_varget,nc_file_id,'co_fg',co_fg
     ncdf_varget,nc_file_id,'co_ave_kern',ak
     ncdf_varget,nc_file_id,'co_func_indxs',co_func_indxs
     ncdf_varget,nc_file_id,'co_func_last_indx',co_func_last_indx
ak_nlev=n_elements(co_func_indxs)
; co_fg [nobs x nlev]
; co_func_pres [9]: CO trapezoid pressure layers
; co_func_last_indx [nobs]: trapezoid layer intersecting surface pressure
; co_ave_kern: [nobs x 9 x 9]: CO AK matrix on trapezoid layers
; co_bot_func_pres_eff [nobs]; pressure of trapezoid layer intersection surf pres
; (3) Assign full reconstructed AK matrix as reported in files.
; ---------------------------------------
; RECONSTRUCT THE AK MATRIX (ndim x ndim)
; ---------------------------------------
; - ak_conv.pro: ak_rec, ndim, lambda_c, phi_lim, lambda_vec, eigvec_mat, dof, ak
; - NO NEED TO RUN AK_CONV
; - read reconstructed ak from the AK file
; (4) Adjust trapezoid pressure layers to surface pressure
; ak_conv.pro: changlev, f93.Psurf, pobs, numlev, nlev, lev_in, nlev_fin, lev_fin
;       nlev = n_elements(l2_ak.co_func_indxs)
;       nlev_fin = l2_ak.co_func_last_indx
;       lev_in = l2_ak.co_func_indxs
;       lev_fin = lev_in(0:nlev_fin-1)
; - NO NEED TO RUN CHANGLEV âCAN DERIVE ALL FROM NETCDF FIELDS
; - this section of code replaces the changelev.pro routine
lev_in = co_func_indxs;[ak_nlev]
lev_fin = intarr(ak_nlev,nobs)-9999; number of trapezoid layers above surface at retrieval site
nlev_fin=intarr(nobs)-9999

for iobs = 0,nobs-1 do begin
        lsurf = co_func_last_indx(iobs);
        lev_fin(0:lsurf-1,iobs)=lev_in(0:lsurf-1)
        nlev_fin(iobs)=lsurf
endfor

; (5) Adjust CO first guess to surface pressure
co_apr=fltarr(ret_nlev,nobs)-9999.
for iobs=0,nobs-1 do begin
        idx=where(pmult(*,iobs) gt 0)
        co_apr(idx,iobs)=co_fg(iobs,idx)*pmult(idx,iobs)
endfor
nchem=0l
nl=0l
itotal=0l
  ifile=curtain_dir+bnname+'_curtain_1x1_mission.dat'
  close,20
  openr,20,ifile,/f77
  readu,20,nchem,nl,itotal
;  writeu,20,sco
  utsec=fltarr(itotal)
  xco=fltarr(itotal)
  yco=fltarr(itotal)
  psfc_mod=fltarr(itotal)
  ptrop_mod=fltarr(itotal)
  pcurt=fltarr(nl,itotal)
  curtain=fltarr(nchem,nl,itotal)
  uucurt=fltarr(nl,itotal)
  vvcurt=fltarr(nl,itotal)
  thcurt=fltarr(nl,itotal)
  readu,20,utcsec
  readu,20,xco
  readu,20,yco
  readu,20,psfc_mod
  readu,20,ptrop_mod
  readu,20,pcurt
  readu,20,curtain
  readu,20,uucurt
  readu,20,vvcurt
  readu,20,thcurt

  close,20
;---------------
; CONVOLVE TRUTH
;---------------
; Degrade the truth onto the trapezoid space, convolve it to the ave,
; bring it back to 100 level grid. this is the convoluted truth to
; compare to the retrieval

style = 1L
htop = 1
hbot = 1

; Retreival pressure layers
; loop over all retrieval scenes
co_mod=-9999.+0.* co_ret
co_mod_ak=-9999.+0.* co_ret
for iobs = 0,nobs-1 do begin

        x_a = co_apr(*,iobs); a priori
        x_r = co_ret(*,iobs); retrieval
        x_rd = co_ret_pcol(*,iobs); retrieval partial column

; Now compute pseudo inverse of trapezois matrix
; Equation 11 of Maddy and Barnet, IEEE TGRS, 2008 (MB08)
;   calc_finv, style, nlev_fin, lev_fin, numlev, htp, hbt, pobs, finv, $
;           fine=finex
      ilev = where(pmult(*,iobs) gt 0.0); indices of pressure layers above surface
      ret_nlev = n_elements(ilev); number pressure layers above surface at retrieval site
      ret_plev = effective_pressure(ilev,iobs); pressure [hPa] above surface
      trap_nlev = nlev_fin(iobs); number of trapezoide pressure hingepoints
      trap_plev_idx = lev_fin(0:trap_nlev-1,iobs); indices of trapezoid pressure hingepoints
if trap_nlev eq 0 then begin
print,'trap_nlev eq 0'
goto, skipit
endif
      calc_finv, style, trap_nlev, trap_plev_idx, ret_nlev, htop, hbot, ret_plev, finv, $
                        fine=finex

;
; 1) Interpolate true profile (t) onto high resolution effective pressure levels (peff[0:numlev-1] )
;
x_t=fltarr(ret_nlev)
tdum=reform(curtain(1,*,iobs),nl)
pdum=reform(pcurt(*,iobs),nl)
pmin=min(pdum)
pmax=max(pdum)
peffdum= ret_plev
index=where(peffdum ge pmin and peffdum le pmax)
if index(0) ne -1 then x_t(index)=interpol(tdum,pdum,peffdum(index))
index=where(peffdum lt pmin)
if index(0) ne -1 then x_t(index)=tdum(0)
index=where(peffdum gt pmax)
if index(0) ne -1 then x_t(index)=tdum(nl-1)
;
; Convolve "true" trace gas profiles with the NUCAPS averaging kernels. 
; The steps to accomplish this have been adapted from IDL tools originally 
; developed for NASA AIRS CO retrievals and are outlined below.
; 
;1) Interpolate true profile (t) onto high resolution effective pressure levels (peff[0:numlev-1] ) 
;
;2) Convert (x_t) from ppbv to partial column (x_td, mol/cm^2) using the ratio of the retrieved 
;   mixing ratio (x_r) to the retrieved partial column density (x_rd)
;
;   x_td[0:numlev-1] =x_t[0:numlev-1] *(x_rd[0:numlev-1]) /x_r[0:numlev-1])
;
;3) Compute the difference between the natural log of the "true" and apriori partial column profile
;
;   delta_x = ALOG(x_td[0:numlev-1]) - ALOG(x_ad[0:numlev-1])
;
;4) Project onto trapezoid basis using the pseudo inverse of trapezoid matrix (finv), then convolve 
;   the profile with the averaging kernel (ak) and project back onto the fine grid (peff) using the 
;   transpose of the pseudo inverse of the trapezoid matrix (finex). See Equation 13, 16-17 of Maddy 
;   and Barnet, IEEE TGRS, 2008 (MB08)
;
;   x_td_conv = EXP( ALOG(x_ad) + TRANSPOSE(finex)#ak#finv#delta_x )
;
;5) Convert (x_td_conv) partial column back to mixing ratio
;
;   x_t_conv[0:numlev-1] =x_td_conv[0:numlev-1] *(x_r[0:numlev-1]) /x_rd[0:numlev-1])
;
x_td=x_t
x_td_conv=x_t
x_t_conv=x_t
delta_x=x_t
;
;2) Convert (x_t) from ppbv to partial column (x_td, mol/cm^2) using the ratio of the retrieved 
;   mixing ratio (x_r) to the retrieved partial column density (x_rd)
;
x_t=1.e9*x_t
x_td =x_t*x_rd/x_r
;
; apriori is already in partial column density
;
x_a=x_a*x_r/x_rd
x_ad =x_a*x_rd/x_r
;
;3) Compute the difference between the natural log of the "true" and apriori partial column profile
;
    delta_x = ALOG(x_td) - ALOG(x_ad)
;
;4) Project onto trapezoid basis using the pseudo inverse of trapezoid matrix (finv), then convolve 
;   the profile with the averaging kernel (ak) and project back onto the fine grid (peff) using the 
;   transpose of the pseudo inverse of the trapezoid matrix (finex). See Equation 13, 16-17 of Maddy 
;   and Barnet, IEEE TGRS, 2008 (MB08)
;
   x_addum=x_ad
   finexdum=finex
;
; get proper dimensions
;
result=size(finexdum)
d0=result(1)
   akdum=reform(ak(iobs,0:d0-1,0:d0-1))
   finvdum=finv
   delta_xdum=delta_x
   x_td_conv = EXP( ALOG(x_addum) + TRANSPOSE(finexdum)#akdum#finvdum#delta_xdum )
;
;5) Convert (x_td_conv) partial column back to mixing ratio
;
   x_t_conv =x_td_conv*x_r/x_rd
;
; save
;
result=size(x_t)
d0=result(1)
   co_apr(0:d0-1,iobs)=x_a(0:d0-1)
   co_mod(0:d0-1,iobs)=x_t
   co_mod_ak(0:d0-1,iobs)=x_t_conv
skipit:
endfor
nucaps_co=co_ret*1.e-9
nucaps_co_apr=co_apr*1.e-9
raqms_co=co_mod*1.e-9
raqms_co_ak=co_mod_ak*1.e-9
    ;  factor for conversion to column in molc/cm^2
    fac=1.e-18*1.0e4*6.023e23/28.97/9.8/1000.
  psurf=psfc2d
  pcrit=0.*psurf
  xdata0=fltarr(nobs)
  xdata1=fltarr(nobs)
  xdata2=fltarr(nobs)
  xdata3=fltarr(nobs)

help,qual
help,effective_pressure
nlevmax=100l
    for ifor=0,nobs-1 do begin
    if qual(ifor) eq 1 then begin
xdata0(ifor)=-9999.
xdata1(ifor)=-9999.
xdata2(ifor)=-9999.
xdata3(ifor)=-9999.
endif
    if qual(ifor) eq 0 then begin
; changed order of array on 08/08
pdum=reform(effective_pressure(*,ifor),nlevmax)
index=where(pdum ne -9999.)
nval=n_elements(index)
nlev_max=index(nval-1)
         for llev=0,nlev_max do begin
             if llev eq 0 then ptop=0.
             if llev gt 0 then ptop=.5*(effective_pressure(llev,ifor)+effective_pressure(llev-1,ifor))
             if llev lt nlev_max then pbot=.5*(effective_pressure(llev+1,ifor)+effective_pressure(llev,ifor))
             if llev eq nlev_max then pbot=.5*(psfc2d(ifor)+effective_pressure(llev,ifor))
             dp=pbot-ptop
;  calculate column co from surface
             if nucaps_co(llev,ifor) ne -9999. then begin
               codata=nucaps_co(llev,ifor)
               xdata0(ifor)=xdata0(ifor)+fac*codata*dp
               codata=nucaps_co_apr(llev,ifor)
               xdata1(ifor)=xdata1(ifor)+fac*codata*dp
               codata=raqms_co(llev,ifor)
               xdata2(ifor)=xdata2(ifor)+fac*codata*dp
               codata=raqms_co_ak(llev,ifor)
               xdata3(ifor)=xdata3(ifor)+fac*codata*dp

             endif
         endfor
      endif
      endfor
    cocol_obs=xdata0
    cocol_apr=xdata1
    cocol_mod=xdata2
    cocol_mod_ak=xdata3
;
; accumulate
;
if icount eq 0 then begin
alat_sav=alat
alon_sav=alon
year_sav=year
month_sav=month
day_sav=day
hour_sav=hour
minute_sav=minute
second_sav=second
;
pland_sav=pland
nlev_sav=nlev
qual_sav=qual
cocol_obs_sav=cocol_obs
cocol_apr_sav=cocol_apr
cocol_mod_sav=cocol_mod
cocol_mod_ak_sav=cocol_mod_ak
endif
if icount gt 0 then begin
alat_sav=[alat_sav,alat]
alon_sav=[alon_sav,alon]
year_sav=[year_sav,year]
month_sav=[month_sav,month]
day_sav=[day_sav,day]
hour_sav=[hour_sav,hour]
minute_sav=[minute_sav,minute]
second_sav=[second_sav,second]
;
pland_sav=[pland_sav,pland]
nlev_sav=[nlev_sav,nlev]
qual_sav=[qual_sav,qual]
cocol_obs_sav=[cocol_obs_sav,cocol_obs]
cocol_apr_sav=[cocol_apr_sav,cocol_apr]
cocol_mod_sav=[cocol_mod_sav,cocol_mod]
cocol_mod_ak_sav=[cocol_mod_ak_sav,cocol_mod_ak]
endif
icount=icount+1
jumpout:
endfor
close,1
title=' NUCAPS Column CO'
unit='(1e18 mol/cm!u2!n) July 22, 2019 PM Orbits'

set_viewport,.1,.5,.15,.9
mcolor=253.
;map_set,/continents,/us,limit=[15,195,60,255],$
;map_set,0,-180,0,/continents,/us,limit=[15,75,60,255],$
map_set,/continents,/us,$
title='SciEDR NUCAPS Column CO'
a=findgen(9)*(2*!pi/8.)
usersym,cos(a),sin(a),/fill
;index=where(lon_sav ge 195 and lon_sav le 255. and lat_sav ge 15 and lat_sav lt 60. and qual_sav eq 0l)
;index=where(lon_sav ge 75 and lon_sav le 255. and lat_sav ge 15 and lat_sav lt 60. and qual_sav eq 0l)
index=where(qual_sav eq 0l)


if index(0) ne -1 then begin
clevel=0.5+3.5*findgen(31)/30.
color=icmm2*(cocol_obs_sav(index)-0.5)/3.5
cindex=where(color lt 0.)
if cindex(0) ne -1 then color(cindex)=0B
cindex=where(color gt icmm2)
if cindex(0) ne -1 then color(cindex)=icmm2
!psym=8
plots,alon_sav(index),alat_sav(index),$
color=color
endif
!psym=0
;map_set,/continents,/us,limit=[15,195,60,255],$
;map_set,0,-180,0,/continents,/us,limit=[15,75,60,255],$
map_set,/continents,/us,$
/noeras
title=' RAQMS (with AK) Column CO'
unit='(1e18 mol/cm!u2!n) July 22, 2019 PM Orbits'

set_viewport,.5,.9,.15,.9
mcolor=253.
;map_set,/continents,/us,limit=[15,195,60,255],$
;map_set,0,-180,0,/continents,/us,limit=[15,75,60,255],$
map_set,/continents,/us,$
title='RAQMS (with AK) Column CO',/noerase
a=findgen(9)*(2*!pi/8.)
usersym,cos(a),sin(a),/fill
;index=where(lon_sav ge 195 and lon_sav le 255. and lat_sav ge 15 and lat_sav lt 60. and qual_sav eq 0l)
;index=where(lon_sav ge 75 and lon_sav le 255. and lat_sav ge 15 and lat_sav lt 60. and qual_sav eq 0l)
index=where(qual_sav eq 0l)


if index(0) ne -1 then begin
clevel=0.5+3.5*findgen(31)/30.
color=icmm2*(cocol_mod_ak_sav(index)-0.5)/3.5
cindex=where(color lt 0.)
if cindex(0) ne -1 then color(cindex)=0B
cindex=where(color gt icmm2)
if cindex(0) ne -1 then color(cindex)=icmm2
!psym=8
plots,alon_sav(index),alat_sav(index),$
color=color
endif
!psym=0
;map_set,/continents,/us,limit=[15,195,60,255],$
;map_set,0,-180,0,/continents,/us,limit=[15,75,60,255],$
map_set,/continents,/us,$
/noeras
!p.thick=1
; color bar
        !psym=0
        imin=min(clevel)
        imax=max(clevel)
        set_viewport,.2,.8,.1,.125
        !type=2^2+2^3+2^6
        plot,[imin,imax],[0,0],yrange=[0,10],xrange=[imin,imax],$
        xtitle=unit,/noeras


        ybox=[0,10,10,0,0]
        x2=imin
        dx=(imax-imin)/float(icmm2)
        for j=0,icmm2 do begin
            xbox=[x2,x2,x2+dx,x2+dx,x2]
            polyfill,xbox,ybox,color=j
            x2=x2+dx
        endfor
if setplot eq 'Z' then begin
image=tvrd(0,0,nxpng,nypng)
image_byt=bytscl(image,min=0,max=255)
;transparent=bytarr(256)+255B
;transparent(255:255)=0
tvlct,r,g,b,/get

write_png,'NUCAPS_RAQMS_AK_PM_Column_CO.July.22.2019.qc.eq.0.png',image_byt,r,g,b
endif
endfor
end
